PHP                                                                        NEWS
|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
01 Oct 2020, PHP 7.2.34

- Core:
  . Fixed bug #79699 (PHP parses encoded cookie names so malicious `__Host-`
    cookies can be sent). (CVE-2020-7070) (Stas)

- OpenSSL:
  . Fixed bug #79601 (Wrong ciphertext/tag in AES-CCM encryption for a 12
    bytes IV). (CVE-2020-7069) (Jakub Zelenka)

06 Aug 2020, PHP 7.2.33

- Core:
  . Fixed bug #79877 (getimagesize function silently truncates after a null 
    byte) (cmb)

- Phar:
  . Fixed bug #79797 (Use of freed hash key in the phar_parse_zipfile
    function). (CVE-2020-7068) (cmb)

09 Jul 2020, PHP 7.2.32

- Core:
  . No source changes to this release.
    Vesion number added for reproduction of Windows builds. (cmb)

14 May 2020, PHP 7.2.31

- Core:
  . Fixed bug #78875 (Long filenames cause OOM and temp files are not cleaned). 
    (CVE-2019-11048) (cmb)
  . Fixed bug #78876 (Long variables in multipart/form-data cause OOM and temp 
    files are not cleaned). (CVE-2019-11048) (cmb)

16 Apr 2020, PHP 7.2.30

- Standard:
  . Fixed bug #79468 (SIGSEGV when closing stream handle with a stream filter
    appended). (dinosaur)
  . Fixed bug #79330 (shell_exec() silently truncates after a null byte). (stas)
  . Fixed bug #79465 (OOB Read in urldecode()). (stas)

19 Mar 2020, PHP 7.2.29

- EXIF:
  . Fixed bug #79282 (Use-of-uninitialized-value in exif). (CVE-2020-7064) 
    (Nikita)

- Standard: 
  . Fixed bug #79329 (get_headers() silently truncates after a null byte) 
    (CVE-2020-7066). (cmb)

20 Feb 2020, PHP 7.2.28

- DOM:
  . Fixed bug #77569: (Write Access Violation in DomImplementation). (Nikita,
    cmb)

- Phar:
  . Fixed bug #79082 (Files added to tar with Phar::buildFromIterator have
    all-access permissions). (CVE-2020-7063) (stas)

- Session:
  . Fixed bug #79221 (Null Pointer Dereference in PHP Session Upload Progress).
    (CVE-2020-7062) (stas)

23 Jan 2020, PHP 7.2.27

- Mbstring:
  . Fixed bug #79037 (global buffer-overflow in `mbfl_filt_conv_big5_wchar`). 
    (CVE-2020-7060) (Nikita)

- Session:
  . Fixed bug #79091 (heap use-after-free in session_create_id()). (cmb, Nikita)

- Standard:
  . Fixed bug #79099 (OOB read in php_strip_tags_ex). (CVE-2020-7059). (cmb)

18 Dec 2019, PHP 7.2.26

- Bcmath:
  . Fixed bug #78878 (Buffer underflow in bc_shift_addsub). (CVE-2019-11046).
    (cmb)

- Core:
  . Fixed bug #78862 (link() silently truncates after a null byte on Windows).
    (CVE-2019-11044). (cmb)
  . Fixed bug #78863 (DirectoryIterator class silently truncates after a null
    byte). (CVE-2019-11045). (cmb)

- EXIF:
  . Fixed bug #78793 (Use-after-free in exif parsing under memory sanitizer).
    (CVE-2019-11050). (Nikita)
  . Fixed bug #78910 (Heap-buffer-overflow READ in exif). (CVE-2019-11047).
    (Nikita)

- GD:
  . Fixed bug #78849 (GD build broken with -D SIGNED_COMPARE_SLOW). (cmb)

- Intl:
  . Fixed bug #78804 (Segmentation fault in Locale::filterMatches). (Stas)

- OPcache:
  . Fixed $x = (bool)$x; with opcache (should emit undeclared variable notice).
    (Tyson Andre)

- Standard:
  . Fixed bug #78759 (array_search in $GLOBALS). (Nikita)
  . Fixed bug #78833 (Integer overflow in pack causes out-of-bound access).
    (cmb)
  . Fixed bug #78814 (strip_tags allows / in tag name => whitelist bypass).
    (cmb)

21 Nov 2019, PHP 7.2.25

- Core:
  . Fixed bug #78656 (Parse errors classified as highest log-level). (Erik
    Lundin)
  . Fixed bug #78752 (Segfault if GC triggered while generator stack frame is
    being destroyed). (Nikita)
  . Fixed bug #78689 (Closure::fromCallable() doesn't handle
    [Closure, '__invoke']). (Nikita)

- COM:
  . Fixed bug #78694 (Appending to a variant array causes segfault). (cmb)

- Date:
  . Fixed bug #70153 (\DateInterval incorrectly unserialized). (Maksim Iakunin)
  . Fixed bug #78751 (Serialising DatePeriod converts DateTimeImmutable). (cmb)

- Iconv:
  . Fixed bug #78642 (Wrong libiconv version displayed). (gedas at martynas,
    cmb).

- OpCache:
  . Fixed bug #78654 (Incorrectly computed opcache checksum on files with
    non-ascii characters). (mhagstrand)
  . Fixed bug #78747 (OpCache corrupts custom extension result). (Nikita)

- OpenSSL:
  . Fixed bug #78775 (TLS issues from HTTP request affecting other encrypted
    connections). (Nikita)

- Reflection:
  . Fixed bug #78697 (ReflectionClass::ImplementsInterface - inaccurate error
    message with traits). (villfa)

- Sockets:
  . Fixed bug #78665 (Multicasting may leak memory). (cmb)

24 Oct 2019, PHP 7.2.24

- Core:
  . Fixed bug #78535 (auto_detect_line_endings value not parsed as bool).
    (bugreportuser)
  . Fixed bug #78620 (Out of memory error). (cmb, Nikita)

- Exif:
  . Fixed bug #78442 ('Illegal component' on exif_read_data since PHP7)
	(Kalle)

- FPM:
  . Fixed bug #78599 (env_path_info underflow in fpm_main.c can lead to RCE).
    (CVE-2019-11043) (Jakub Zelenka)

- MBString:
  . Fixed bug #78579 (mb_decode_numericentity: args number inconsistency).
    (cmb)
  . Fixed bug #78609 (mb_check_encoding() no longer supports stringable
    objects). (cmb)

- MySQLi:
  . Fixed bug #76809 (SSL settings aren't respected when persistent connections 
    are used). (fabiomsouto)

- PDO_MySQL:
  . Fixed bug #78623 (Regression caused by "SP call yields additional empty
    result set"). (cmb)

- Session:
  . Fixed bug #78624 (session_gc return value for user defined session 
    handlers). (bshaffer)

- Standard:
  . Fixed bug #76342 (file_get_contents waits twice specified timeout).
    (Thomas Calvet)
  . Fixed bug #78612 (strtr leaks memory when integer keys are used and the
    subject string shorter). (Nikita)
  . Fixed bug #76859 (stream_get_line skips data if used with data-generating 
    filter). (kkopachev)

- Zip:
  . Fixed bug #78641 (addGlob can modify given remove_path value). (cmb)

26 Sep 2019, PHP 7.2.23

- Core:
  . Fixed bug #78220 (Can't access OneDrive folder). (cmb, ab)
  . Fixed bug #78412 (Generator incorrectly reports non-releasable $this as GC
    child). (Nikita)

- FastCGI:
  . Fixed bug #78469 (FastCGI on_accept hook is not called when using named
    pipes on Windows). (Sergei Turchanov)

- MySQLnd:
  . Fixed connect_attr issues and added the _server_host connection attribute.
    (Qianqian Bu)

- ODBC:
  . Fixed bug #78473 (odbc_close() closes arbitrary resources). (cmb)

- PDO_MySQL:
  . Fixed bug #41997 (SP call yields additional empty result set). (cmb)

- sodium:
  . Fixed bug #78510 (Partially uninitialized buffer returned by
    sodium_crypto_generichash_init()). (Frank Denis, cmb)

- SPL:
  . Fixed bug #72884 (SplObject isCloneable() returns true but errs on clone).
    (Chu Zhaowei)

29 Aug 2019, PHP 7.2.22

- Core:
  . Fixed bug #78363 (Buffer overflow in zendparse). (Nikita)
  . Fixed bug #78379 (Cast to object confuses GC, causes crash). (Dmitry)

- Curl:
  . Fixed bug #77946 (Bad cURL resources returned by curl_multi_info_read()).
    (Abyr Valg)

- Exif:
  . Fixed bug #78333 (Exif crash (bus error) due to wrong alignment and
    invalid cast). (Nikita)

- Iconv:
  . Fixed bug #78342 (Bus error in configure test for iconv //IGNORE). (Rainer
    Jung)

- LiteSpeed:
  . Updated to LiteSpeed SAPI V7.5 (Fixed clean shutdown). (George Wang)

- MySQLnd:
  . Fixed bug #78179 (MariaDB server version incorrectly detected). (cmb)

- Opcache:
  . Fixed bug #77191 (Assertion failure in dce_live_ranges() when silencing is
    used). (Nikita)

- Standard:
  . Fixed bug #69100 (Bus error from stream_copy_to_stream (file -> SSL stream)
    with invalid length). (Nikita)
  . Fixed bug #78282 (atime and mtime mismatch). (cmb)
  . Fixed bug #78326 (improper memory deallocation on stream_get_contents()
    with fixed length buffer). (Albert Casademont)

01 Aug 2019, PHP 7.2.21

- Date:
  . Fixed bug #69044 (discrepency between time and microtime). (krakjoe)

- EXIF:
  . Fixed bug #78256 (heap-buffer-overflow on exif_process_user_comment).
    (CVE-2019-11042) (Stas)
  . Fixed bug #78222 (heap-buffer-overflow on exif_scan_thumbnail).
    (CVE-2019-11041) (Stas)

- Fileinfo:
  . Fixed bug #78183 (finfo_file shows wrong mime-type for .tga file).
    (Joshua Westerheide)

- FTP:
  . Fixed bug #77124 (FTP with SSL memory leak). (Nikita)

- Libxml:
  . Fixed bug #78279 (libxml_disable_entity_loader settings is shared between
    requests (cgi-fcgi)). (Nikita)

- LiteSpeed:
  . Updated to LiteSpeed SAPI V7.4.3 (increased response header count limit from
    100 to 1000, added crash handler to cleanly shutdown PHP request, added
    CloudLinux mod_lsapi mode). (George Wang)
  . Fixed bug #76058 (After "POST data can't be buffered", using php://input
    makes huge tmp files). (George Wang)

- Openssl:
  . Fixed bug #78231 (Segmentation fault upon stream_socket_accept of exported
    socket-to-stream). (Nikita)

- OPcache:
  . Fixed bug #78189 (file cache strips last character of uname hash). (cmb)
  . Fixed bug #78202 (Opcache stats for cache hits are capped at 32bit NUM).
    (cmb)
  . Fixed bug #78291 (opcache_get_configuration doesn't list all directives).
    (Andrew Collington)

- Phar:
  . Fixed bug #77919 (Potential UAF in Phar RSHUTDOWN). (cmb)

- Phpdbg:
  . Fixed bug #78297 (Include unexistent file memory leak). (Nikita)

- PDO_Sqlite:
  . Fixed bug #78192 (SegFault when reuse statement after schema has changed).
    (Vincent Quatrevieux)

- SQLite:
  . Upgraded to SQLite 3.28.0. (cmb)

- Standard:
  . Fixed bug #78241 (touch() does not handle dates after 2038 in PHP 64-bit).
    (cmb)
  . Fixed bug #78269 (password_hash uses weak options for argon2). (Remi)

- XMLRPC:
  . Fixed bug #78173 (XML-RPC mutates immutable objects during encoding).
    (Asher Baker)

04 Jul 2019, PHP 7.2.20

- Core:
  . Fixed bug #76980 (Interface gets skipped if autoloader throws an exception).
    (Nikita)

- DOM:
  . Fixed bug #78025 (segfault when accessing properties of DOMDocumentType).
    (cmb)

- MySQLi:
  . Fixed bug #77956 (When mysqli.allow_local_infile = Off, use a meaningful
    error message). (Sjon Hortensius)
  . Fixed bug #38546 (bindParam incorrect processing of bool types).
    (camporter)

- Opcache:
  . Fixed bug #78106 (Path resolution fails if opcache disabled during request).
    (Nikita)
  . Fixed bug #78185 (File cache no longer works). (Dmitry)

- OpenSSL:
  . Fixed bug #78079 (openssl_encrypt_ccm.phpt fails with OpenSSL 1.1.1c).
    (Jakub Zelenka)

- Sockets:
  . Fixed bug #78038 (Socket_select fails when resource array contains
    references). (Nikita)

- Standard:
  . Fixed bug #77135 (Extract with EXTR_SKIP should skip $this).
    (Craig Duncan, Dmitry)
  . Fixed bug ##77937	(preg_match failed). (cmb, Anatol)

- Zip:
  . Fixed bug #76345 (zip.h not found). (Michael Maroszek)

30 May 2019, PHP 7.2.19

- Date:
  . Fixed bug #77909 (DatePeriod::__construct() with invalid recurrence count
    value). (Ignace Nyamagana Butera)

- EXIF:
  . Fixed bug #77988 (heap-buffer-overflow on php_jpg_get16).
    (CVE-2019-11040) (Stas)

- FPM:
  . Fixed bug #77934 (php-fpm kill -USR2 not working). (Jakub Zelenka)
  . Fixed bug #77921 (static.php.net doesn't work anymore). (Peter Kokot)

- GD:
  . Fixed bug #77943 (imageantialias($image, false); does not work). (cmb)
  . Fixed bug #77973 (Uninitialized read in gdImageCreateFromXbm).
    (CVE-2019-11038) (cmb)

- Iconv:
  . Fixed bug #78069 (Out-of-bounds read in iconv.c:_php_iconv_mime_decode()
    due to integer overflow). (CVE-2019-11039). (maris dot adam)

- JSON:
  . Fixed bug #77843 (Use after free with json serializer). (Nikita)

- Opcache:
  . Fixed possible crashes, because of inconsistent PCRE cache and opcache
    SHM reset. (Alexey Kalinin, Dmitry)

- PDO_MySQL:
  . Fixed bug #77944 (Wrong meta pdo_type for bigint on LLP64). (cmb)

- Reflection:
  . Fixed bug #75186 (Inconsistent reflection of Closure:::__invoke()). (Nikita)

- Session:
  . Fixed bug #77911 (Wrong warning for session.sid_bits_per_character). (cmb)

- SPL:
  . Fixed bug #77024 (SplFileObject::__toString() may return array). (Craig
    Duncan)

- SQLite:
  . Fixed bug #77967 (Bypassing open_basedir restrictions via file uris). (Stas)

02 May 2019, PHP 7.2.18

- CLI:
  . Fixed bug #77794 (Incorrect Date header format in built-in server).
    (kelunik)

- EXIF
  . Fixed bug #77950 (Heap-buffer-overflow in _estrndup via exif_process_IFD_TAG).
    (CVE-2019-11036) (Stas)

- Interbase:
  . Fixed bug #72175 (Impossibility of creating multiple connections to
    Interbase with php 7.x). (Nikita)

- Intl:
  . Fixed bug #77895 (IntlDateFormatter::create fails in strict mode if $locale
    = null). (Nikita)

- litespeed:
  . LiteSpeed SAPI 7.3.1, better process management, new API function
    litespeed_finish_request(). (George Wang)

- Mail
  . Fixed bug #77821 (Potential heap corruption in TSendMail()). (cmb)

- PCRE:
  . Fixed bug #77827 (preg_match does not ignore \r in regex flags). (requinix,
    cmb)

- PDO:
  . Fixed bug #77849 (Disable cloning of PDO handle/connection objects).
    (camporter)

- phpdbg:
  . Fixed bug #76801 (too many open files). (alekitto)
  . Fixed bug #77800 (phpdbg segfaults on listing some conditional breakpoints).
    (krakjoe)
  . Fixed bug #77805 (phpdbg build fails when readline is shared). (krakjoe)

- Reflection:
  . Fixed bug #77772 (ReflectionClass::getMethods(null) doesn't work). (Nikita)
  . Fixed bug #77882 (Different behavior: always calls destructor). (Nikita)

- SOAP:
  . Fixed bug #77945 (Segmentation fault when constructing SoapClient with
    WSDL_CACHE_BOTH). (Nikita)

- Standard:
  . Fixed bug #77680 (recursive mkdir on ftp stream wrapper is incorrect).
    (Vlad Temian)
  . Fixed bug #77844 (Crash due to null pointer in parse_ini_string with
    INI_SCANNER_TYPED). (Nikita)
  . Fixed bug #77853 (Inconsistent substr_compare behaviour with empty
    haystack). (Nikita)

04 Apr 2019, PHP 7.2.17

- Core:
  . Fixed bug #77738 (Nullptr deref in zend_compile_expr). (Laruence)
  . Fixed bug #77660 (Segmentation fault on break 2147483648). (Laruence)
  . Fixed bug #77652 (Anonymous classes can lose their interface information).
    (Nikita)
  . Fixed bug #77676 (Unable to run tests when building shared extension on
    AIX). (Kevin Adler)

- Bcmath:
  . Fixed bug #77742 (bcpow() implementation related to gcc compiler
    optimization). (Nikita)

- COM:
  . Fixed bug #77578 (Crash when php unload). (cmb)

- Date:
  . Fixed bug #50020 (DateInterval:createDateFromString() silently fails).
    (Derick)
  . Fixed bug #75113 (Added DatePeriod::getRecurrences() method). (Ignace
    Nyamagana Butera)

- EXIF:
  . Fixed bug #77753 (Heap-buffer-overflow in php_ifd_get32s). (CVE-2019-11034)
    (Stas)
  . Fixed bug #77831 (Heap-buffer-overflow in exif_iif_add_value).
    (CVE-2019-11035) (Stas)

- FPM:
  . Fixed bug #77677 (FPM fails to build on AIX due to missing WCOREDUMP).
    (Kevin Adler)

- GD:
  . Fixed bug #77700 (Writing truecolor images as GIF ignores interlace flag).
    (cmb)

- MySQLi:
  . Fixed bug #77597 (mysqli_fetch_field hangs scripts). (Nikita)

- Opcache:
  . Fixed bug #77691 (Opcache passes wrong value for inline array push
    assignments). (Nikita)
  . Fixed bug #77743 (Incorrect pi node insertion for jmpznz with identical
    successors). (Nikita)

- phpdbg:
  . Fixed bug #77767 (phpdbg break cmd aliases listed in help do not match
    actual aliases). (Miriam Lauter)

- sodium:
  . Fixed bug #77646 (sign_detached() strings not terminated). (Frank)

- SQLite3:
  . Added sqlite3.defensive INI directive. (BohwaZ)

- Standard:
  . Fixed bug #77664 (Segmentation fault when using undefined constant in
    custom wrapper). (Laruence)
  . Fixed bug #77669 (Crash in extract() when overwriting extracted array).
    (Nikita)
  . Fixed bug #76717 (var_export() does not create a parsable value for
    PHP_INT_MIN). (Nikita)
  . Fixed bug #77765 (FTP stream wrapper should set the directory as
    executable). (Vlad Temian)

07 Mar 2019, PHP 7.2.16

- Core:
  . Fixed bug #77589 (Core dump using parse_ini_string with numeric sections).
    (Laruence)
  . Fixed bug #77630 (rename() across the device may allow unwanted access
    during processing). (Stas)

- COM:
  . Fixed bug #77621 (Already defined constants are not properly reported).
    (cmb)

- EXIF:
  . Fixed bug #77509 (Uninitialized read in exif_process_IFD_in_TIFF). (Stas)
  . Fixed bug #77540 (Invalid Read on exif_process_SOFn). (Stas)
  . Fixed bug #77563 (Uninitialized read in exif_process_IFD_in_MAKERNOTE). (Stas)
  . Fixed bug #77659 (Uninitialized read in exif_process_IFD_in_MAKERNOTE). (Stas)

- PDO_OCI:
  . Support Oracle Database tracing attributes ACTION, MODULE,
    CLIENT_INFO, and CLIENT_IDENTIFIER. (Cameron Porter)

- PHAR:
  . Fixed bug #77396 (Null Pointer Dereference in phar_create_or_parse_filename).
    (bishop)

- SPL:
  . Fixed bug #51068 (DirectoryIterator glob:// don't support current path
    relative queries). (Ahmed Abdou)
  . Fixed bug #77431 (openFile() silently truncates after a null byte). (cmb)

- Standard:
  . Fixed bug #77552 (Unintialized php_stream_statbuf in stat functions).
    (John Stevenson)

- MySQL
  . Disabled LOCAL INFILE by default, can be enabled using php.ini directive
    mysqli.allow_local_infile for mysqli, or PDO::MYSQL_ATTR_LOCAL_INFILE
    attribute for pdo_mysql. (Darek Slusarczyk)

07 Feb 2019, PHP 7.2.15

- Core:
  . Fixed bug #77339 (__callStatic may get incorrect arguments). (Dmitry)
  . Fixed bug #77494 (Disabling class causes segfault on member access).
    (Dmitry)
  . Fixed bug #77530 (PHP crashes when parsing `(2)::class`). (Ekin)

- Curl:
  . Fixed bug #76675 (Segfault with H2 server push). (Pedro Magalhães)

- GD:
  . Fixed bug #73281 (imagescale(…, IMG_BILINEAR_FIXED) can cause black border).
    (cmb)
  . Fixed bug #73614 (gdImageFilledArc() doesn't properly draw pies). (cmb)
  . Fixed bug #77272 (imagescale() may return image resource on failure). (cmb)
  . Fixed bug #77391 (1bpp BMPs may fail to be loaded). (Romain Déoux, cmb)
  . Fixed bug #77479 (imagewbmp() segfaults with very large images). (cmb)

- ldap:
  . Fixed bug #77440 (ldap_bind using ldaps or ldap_start_tls()=exception in
    libcrypto-1_1-x64.dll). (Anatol)

- Mbstring:
  . Fixed bug #77454 (mb_scrub() silently truncates after a null byte).
    (64796c6e69 at gmail dot com)

- MySQLnd:
  . Fixed bug #75684 (In mysqlnd_ext_plugin.h the plugin methods family has
    no external visibility). (Anatol)

- Opcache:
  . Fixed bug #77361 (configure fails on 64-bit AIX when opcache enabled).
    (Kevin Adler)

- OpenSSL:
  . Fixed bug #77390 (feof might hang on TLS streams in case of fragmented TLS
    records). (Abyl Valg, Jakub Zelenka)

- PDO:
  . Fixed bug #77273 (array_walk_recursive corrupts value types leading to PDO
    failure). (Nikita)

- phpdbg:
  . Fixed bug #76596 (phpdbg support for display_errors=stderr). (kabel)

- Sockets:
  . Fixed bug #76839 (socket_recvfrom may return an invalid 'from' address
    on MacOS). (Michael Meyer)

- Standard:
  . Fixed bug #77395 (segfault about array_multisort). (Laruence)
  . Fixed bug #77439 (parse_str segfaults when inserting item into existing
    array). (Nikita)

10 Jan 2019, PHP 7.2.14

- Core:
  . Fixed bug #77369 (memcpy with negative length via crafted DNS response). (Stas)
  . Fixed bug #71041 (zend_signal_startup() needs ZEND_API).
    (Valentin V. Bartenev)
  . Fixed bug #76046 (PHP generates "FE_FREE" opcode on the wrong line).
    (Nikita)

- COM:
  . Fixed bug #77177 (Serializing or unserializing COM objects crashes). (cmb)

- Date:
  . Fixed bug #77097 (DateTime::diff gives wrong diff when the actual diff is
    less than 1 second). (Derick)

- Exif:
  . Fixed bug #77184 (Unsigned rational numbers are written out as signed
    rationals). (Colin Basnett)

- GD:
  . Fixed bug #77269 (efree() on uninitialized Heap data in imagescale leads to
    use-after-free). (cmb)
  . Fixed bug #77270 (imagecolormatch Out Of Bounds Write on Heap). (cmb)
  . Fixed bug #77195 (Incorrect error handling of imagecreatefromjpeg()). (cmb)
  . Fixed bug #77198 (auto cropping has insufficient precision). (cmb)
  . Fixed bug #77200 (imagecropauto(…, GD_CROP_SIDES) crops left but not right).
    (cmb)

- IMAP:
  . Fixed bug #77020 (null pointer dereference in imap_mail). (cmb)

- Mbstring:
  . Fixed bug #77370 (Buffer overflow on mb regex functions - fetch_token). (Stas)
  . Fixed bug #77371 (heap buffer overflow in mb regex functions
    - compile_string_node). (Stas)
  . Fixed bug #77381 (heap buffer overflow in multibyte match_at). (Stas)
  . Fixed bug #77382 (heap buffer overflow due to incorrect length in
    expand_case_fold_string). (Stas)
  . Fixed bug #77385 (buffer overflow in fetch_token). (Stas)
  . Fixed bug #77394 (Buffer overflow in multibyte case folding - unicode). (Stas)
  . Fixed bug #77418 (Heap overflow in utf32be_mbc_to_code). (Stas)

- OCI8:
  . Fixed bug #76804 (oci_pconnect with OCI_CRED_EXT not working). (KoenigsKind)
  . Added oci_set_call_timeout() for call timeouts.
  . Added oci_set_db_operation() for the DBOP end-to-end-tracing attribute.

- Opcache:
  . Fixed bug #77215 (CFG assertion failure on multiple finalizing switch
    frees in one block). (Nikita)

- PDO:
  . Handle invalid index passed to PDOStatement::fetchColumn() as error. (Sergei
    Morozov)

- Phar:
  . Fixed bug #77247 (heap buffer overflow in phar_detect_phar_fname_ext). (Stas)

- Sockets:
  . Fixed bug #77136 (Unsupported IPV6_RECVPKTINFO constants on macOS).
    (Mizunashi Mana)

- SQLite3:
  . Fixed bug #77051 (Issue with re-binding on SQLite3). (BohwaZ)

- Xmlrpc:
  . Fixed bug #77242 (heap out of bounds read in xmlrpc_decode()). (cmb)
  . Fixed bug #77380 (Global out of bounds read in xmlrpc base64 code). (Stas)

06 Dec 2018, PHP 7.2.13

- ftp:
  . Fixed bug #77151 (ftp_close(): SSL_read on shutdown). (Remi)

- CLI:
  . Fixed bug #77111 (php-win.exe corrupts unicode symbols from cli
    parameters). (Anatol)

- Fileinfo:
  . Fixed bug #77095 (slowness regression in 7.2/7.3 (compared to 7.1)).
    (Anatol)

- iconv:
  . Fixed bug #77147 (Fixing 60494 ignored ICONV_MIME_DECODE_CONTINUE_ON_ERROR).
    (cmb)

- IMAP:
  . Fixed bug #77153 (imap_open allows to run arbitrary shell commands via
    mailbox parameter). (Stas)

- ODBC:
  . Fixed bug #77079 (odbc_fetch_object has incorrect type signature).
    (Jon Allen)

- Opcache:
  . Fixed bug #77058 (Type inference in opcache causes side effects). (Nikita)
  . Fixed bug #77092 (array_diff_key() - segmentation fault). (Nikita)

- PGSQL:
  . Fixed bug #77047 (pg_convert has a broken regex for the 'TIME WITHOUT
    TIMEZONE' data type). (Andy Gajetzki)

- SOAP:
  . Fixed bug #50675 (SoapClient can't handle object references correctly).
    (Cameron Porter)
  . Fixed bug #76348 (WSDL_CACHE_MEMORY causes Segmentation fault). (cmb)
  . Fixed bug #77141 (Signedness issue in SOAP when precision=-1). (cmb)

- Sockets:
  . Fixed bug #67619 (Validate length on socket_write). (thiagooak)

08 Nov 2018, PHP 7.2.12

- Core:
  . Fixed bug #76846 (Segfault in shutdown function after memory limit error).
    (Nikita)
  . Fixed bug #76946 (Cyclic reference in generator not detected). (Nikita)
  . Fixed bug #77035 (The phpize and ./configure create redundant .deps file).
    (Peter Kokot)
  . Fixed bug #77041 (buildconf should output error messages to stderr)
    (Mizunashi Mana)

- Date:
  . Upgraded timelib to 2017.08. (Derick)
  . Fixed bug #75851 (Year component overflow with date formats "c", "o", "r"
    and "y"). (Adam Saponara)
  . Fixed bug #77007 (fractions in `diff()` are not correctly normalized).
    (Derick)

- FCGI:
  . Fixed #76948 (Failed shutdown/reboot or end session in Windows). (Anatol)
  . Fixed bug #76954 (apache_response_headers removes last character from header
    name). (stodorovic)

- FTP:
  . Fixed bug #76972 (Data truncation due to forceful ssl socket shutdown).
    (Manuel Mausz)

- intl:
  . Fixed bug #76942 (U_ARGUMENT_TYPE_MISMATCH). (anthrax at unixuser dot org)

- Reflection:
  . Fixed bug #76936 (Objects cannot access their private attributes while
    handling reflection errors). (Nikita)
  . Fixed bug #66430 (ReflectionFunction::invoke does not invoke closure with
    object scope). (Nikita)

- Sodium:
  . Some base64 outputs were truncated; this is not the case any more.
    (jedisct1)
  . block sizes >= 256 bytes are now supposed by sodium_pad() even
    when an old version of libsodium has been installed. (jedisct1)
  . Fixed bug #77008 (sodium_pad() could read (but not return nor write)
    uninitialized memory when trying to pad an empty input). (jedisct1)

- Standard:
  . Fixed bug #76965 (INI_SCANNER_RAW doesn't strip trailing whitespace).
    (Pierrick)

- Tidy:
  . Fixed bug #77027 (tidy::getOptDoc() not available on Windows). (cmb)

- XML:
  . Fixed bug #30875 (xml_parse_into_struct() does not resolve entities). (cmb)
  . Add support for getting SKIP_TAGSTART and SKIP_WHITE options. (cmb)

- XMLRPC:
  . Fixed bug #75282 (xmlrpc_encode_request() crashes). (cmb)

11 Oct 2018, PHP 7.2.11

- Core:
  . Fixed bug #76800 (foreach inconsistent if array modified during loop).
    (Dmitry)
  . Fixed bug #76901 (method_exists on SPL iterator passthrough method corrupts
    memory). (Nikita)

- CURL:
  . Fixed bug #76480 (Use curl_multi_wait() so that timeouts are respected).
    (Pierrick)

- iconv:
  . Fixed bug #66828 (iconv_mime_encode Q-encoding longer than it should be).
    (cmb)

- Opcache:
  . Fixed bug #76832 (ZendOPcache.MemoryBase periodically deleted by the OS).
    (Anatol)
  . Fixed bug #76796 (Compile-time evaluation of disabled function in opcache
    causes segfault). (Nikita)

- POSIX:
  . Fixed bug #75696 (posix_getgrnam fails to print details of group). (cmb)

- Reflection:
  . Fixed bug #74454 (Wrong exception being thrown when using ReflectionMethod).
    (cmb)

- Standard:
  . Fixed bug #73457 (Wrong error message when fopen FTP wrapped fails to open
    data connection). (Ville Hukkamäki)
  . Fixed bug #74764 (Bindto IPv6 works with file_get_contents but fails with
    stream_socket_client). (Ville Hukkamäki)
  . Fixed bug #75533 (array_reduce is slow when $carry is large array).
    (Manabu Matsui)

- XMLRPC:
  . Fixed bug #76886 (Can't build xmlrpc with expat). (Thomas Petazzoni, cmb)

- Zlib:
  . Fixed bug #75273 (php_zlib_inflate_filter() may not update bytes_consumed).
    (Martin Burke, cmb)

13 Sep 2018, PHP 7.2.10

- Core:
  . Fixed bug #76754 (parent private constant in extends class memory leak).
    (Laruence)
  . Fixed bug #72443 (Generate enabled extension). (petk)
  . Fixed bug #75797 (Memory leak when using class_alias() in non-debug mode).
    (Massimiliano Braglia)

- Apache2:
  . Fixed bug #76582 (Apache bucket brigade sometimes becomes invalid). (stas)

- Bz2:
  . Fixed arginfo for bzcompress. (Tyson Andre)

- gettext:
  . Fixed bug #76517 (incorrect restoring of LDFLAGS). (sji)

- iconv:
  . Fixed bug #68180 (iconv_mime_decode can return extra characters in a
    header). (cmb)
  . Fixed bug #63839 (iconv_mime_decode_headers function is skipping headers).
    (cmb)
  . Fixed bug #60494 (iconv_mime_decode does ignore special characters). (cmb)
  . Fixed bug #55146 (iconv_mime_decode_headers() skips some headers). (cmb)

- intl:
  . Fixed bug #74484 (MessageFormatter::formatMessage memory corruption with
    11+ named placeholders). (Anatol)

- libxml:
  . Fixed bug #76777 ("public id" parameter of libxml_set_external_entity_loader
    callback undefined). (Ville Hukkamäki)

- mbstring:
  . Fixed bug #76704 (mb_detect_order return value varies based on argument
    type). (cmb)

- Opcache:
  . Fixed bug #76747 (Opcache treats path containing "test.pharma.tld" as a phar
    file). (Laruence)

- OpenSSL:
  . Fixed bug #76705 (unusable ssl => peer_fingerprint in
    stream_context_create()). (Jakub Zelenka)

- phpdbg:
  . Fixed bug #76595 (phpdbg man page contains outdated information).
    (Kevin Abel)

- SPL:
  . Fixed bug #68825 (Exception in DirectoryIterator::getLinkTarget()). (cmb)
  . Fixed bug #68175 (RegexIterator pregFlags are NULL instead of 0). (Tim
    Siebels)

- Standard:
  . Fixed bug #76778 (array_reduce leaks memory if callback throws exception).
    (cmb)

- zlib:
  . Fixed bug #65988 (Zlib version check fails when an include/zlib/ style dir
    is passed to the --with-zlib configure option). (Jay Bonci)
  . Fixed bug #76709 (Minimal required zlib library is 1.2.0.4). (petk)

16 Aug 2018, PHP 7.2.9

- Calendar:
  . Fixed bug #52974 (jewish.c: compile error under Windows with GBK charset).
    (cmb)

- Filter:
  . Fixed bug #76366 (References in sub-array for filtering breaks the filter).
    (ZiHang Gao)

- PDO_Firebird:
  . Fixed bug #76488 (Memory leak when fetching a BLOB field). (Simonov Denis)

- PDO_PgSQL:
  . Fixed bug #75402 (Possible Memory Leak using PDO::CURSOR_SCROLL option).
    (Anatol)

- SQLite3:
  . Fixed #76665 (SQLite3Stmt::bindValue() with SQLITE3_FLOAT doesn't juggle).
    (cmb)

- Standard:
  . Fixed bug #73817 (Incorrect entries in get_html_translation_table). (cmb)
  . Fixed bug #68553 (array_column: null values in $index_key become incrementing
    keys in result). (Laruence)
  . Fixed bug #76643 (Segmentation fault when using `output_add_rewrite_var`).
    (cmb)

- Zip:
  . Fixed bug #76524 (ZipArchive memory leak (OVERWRITE flag and empty archive)).
    (Timur Ibragimov)

19 Jul 2018, PHP 7.2.8

- Core:
  . Fixed bug #76534 (PHP hangs on 'illegal string offset on string references
    with an error handler). (Laruence)
  . Fixed bug #76520 (Object creation leaks memory when executed over HTTP).
    (Nikita)
  . Fixed bug #76502 (Chain of mixed exceptions and errors does not serialize
    properly). (Nikita)

- Date:
  . Fixed bug #76462 (Undefined property: DateInterval::$f). (Anatol)

- EXIF:
  . Fixed bug #76409 (heap use after free in _php_stream_free). (cmb)
  . Fixed bug #76423 (Int Overflow lead to Heap OverFlow in
    exif_thumbnail_extract of exif.c). (Stas)
  . Fixed bug #76557 (heap-buffer-overflow (READ of size 48) while reading exif
    data). (Stas)

- FPM:
  . Fixed bug #73342 (Vulnerability in php-fpm by changing stdin to
    non-blocking). (Nikita)

- GMP:
  . Fixed bug #74670 (Integer Underflow when unserializing GMP and possible
    other classes). (Nikita)

- intl:
  . Fixed bug #76556 (get_debug_info handler for BreakIterator shows wrong
    type). (cmb)

- mbstring:
  . Fixed bug #76532 (Integer overflow and excessive memory usage
    in mb_strimwidth). (MarcusSchwarz)

- Opcache:
  . Fixed bug #76477 (Opcache causes empty return value).
    (Nikita, Laruence)

- PGSQL:
  . Fixed bug #76548 (pg_fetch_result did not fetch the next row). (Anatol)

- phpdbg:
  . Fix arginfo wrt. optional/required parameters. (cmb)

- Reflection:
  . Fixed bug #76536 (PHP crashes with core dump when throwing exception in
    error handler). (Laruence)
  . Fixed bug #75231 (ReflectionProperty#getValue() incorrectly works with
    inherited classes). (Nikita)

- Standard:
  . Fixed bug #76505 (array_merge_recursive() is duplicating sub-array keys).
    (Laruence)
  . Fixed bug #71848 (getimagesize with $imageinfo returns false). (cmb)

- Win32:
  . Fixed bug #76459 (windows linkinfo lacks openbasedir check). (Anatol)

- ZIP:
  . Fixed bug #76461 (OPSYS_Z_CPM defined instead of OPSYS_CPM).
    (Dennis Birkholz, Remi)

07 Jun 2018, PHP 7.2.7

- Core:
  . Fixed bug #76337 (segfault when opcache enabled + extension use
    zend_register_class_alias). (xKhorasan)

- CLI Server:
  . Fixed bug #76333 (PHP built-in server does not find files if root path
    contains special characters). (Anatol)

- OpenSSL:
  . Fixed bug #76296 (openssl_pkey_get_public does not respect open_basedir).
    (Erik Lax, Jakub Zelenka)
  . Fixed bug #76174 (openssl extension fails to build with LibreSSL 2.7).
    (Jakub Zelenka)

- SPL:
  . Fixed bug #76367 (NoRewindIterator segfault 11). (Laruence)

- Standard:
  . Fixed bug #76410 (SIGV in zend_mm_alloc_small). (Laruence)
  . Fixed bug #76335 ("link(): Bad file descriptor" with non-ASCII path).
    (Anatol)

24 May 2018, PHP 7.2.6

- EXIF:
  . Fixed bug #76164 (exif_read_data zend_mm_heap corrupted). (cmb)

- FPM:
  . Fixed bug #76075 --with-fpm-acl wrongly tries to find libacl on FreeBSD.
    (mgorny)

- intl:
  . Fixed bug #74385 (Locale::parseLocale() broken with some arguments).
    (Anatol)

- Opcache:
  . Fixed bug #76205 (PHP-FPM sporadic crash when running Infinitewp). (Dmitry)
  . Fixed bug #76275 (Assertion failure in file cache when unserializing empty
    try_catch_array). (Nikita)
  . Fixed bug #76281 (Opcache causes incorrect "undefined variable" errors).
    (Nikita)

- Reflection:
  . Fixed arginfo of array_replace(_recursive) and array_merge(_recursive).
    (carusogabriel)

- Session:
  . Fixed bug #74892 (Url Rewriting (trans_sid) not working on urls that start
    with "#"). (Andrew Nester)

26 Apr 2018, PHP 7.2.5

- Core:
  . Fixed bug #75722 (Convert valgrind detection to configure option).
    (Michael Heimpold)

- Date:
  . Fixed bug #76131 (mismatch arginfo for date_create). (carusogabriel)

- Exif:
  . Fixed bug #76130 (Heap Buffer Overflow (READ: 1786) in exif_iif_add_value).
    (Stas)

- FPM:
  . Fixed bug #68440 (ERROR: failed to reload: execvp() failed: Argument list
    too long). (Jacob Hipps)
  . Fixed incorrect write to getenv result in FPM reload. (Jakub Zelenka)

- GD:
  . Fixed bug #52070 (imagedashedline() - dashed line sometimes is not visible).
    (cmb)

- iconv:
  . Fixed bug #76249 (stream filter convert.iconv leads to infinite loop on
    invalid sequence). (Stas)

- intl:
  . Fixed bug #76153 (Intl compilation fails with icu4c 61.1). (Anatol)

- ldap:
  . Fixed bug #76248 (Malicious LDAP-Server Response causes Crash). (Stas)

- mbstring:
  . Fixed bug #75944 (Wrong cp1251 detection). (dmk001)
  . Fixed bug #76113 (mbstring does not build with Oniguruma 6.8.1).
    (chrullrich, cmb)

- ODBC:
  . Fixed bug #76088 (ODBC functions are not available by default on Windows).
    (cmb)

- Opcache:
  . Fixed bug #76094 (Access violation when using opcache). (Laruence)

- Phar:
  . Fixed bug #76129 (fix for CVE-2018-5712 may not be complete). (Stas)

- phpdbg:
  . Fixed bug #76143 (Memory corruption: arbitrary NUL overwrite). (Laruence)

- SPL:
  . Fixed bug #76131 (mismatch arginfo for splarray constructor).
    (carusogabriel)

- standard:
  . Fixed bug #74139 (mail.add_x_header default inconsistent with docs). (cmb)
  . Fixed bug #75996 (incorrect url in header for mt_rand). (tatarbj)

29 Mar 2018, PHP 7.2.4

- Core:
  . Fixed bug #76025 (Segfault while throwing exception in error_handler).
    (Dmitry, Laruence)
  . Fixed bug #76044 ('date: illegal option -- -' in ./configure on FreeBSD).
    (Anatol)

- FPM:
  . Fixed bug #75605 (Dumpable FPM child processes allow bypassing opcache
    access controls). (Jakub Zelenka)

- FTP:
  . Fixed ftp_pasv arginfo. (carusogabriel)

-GD:
  . Fixed bug #73957 (signed integer conversion in imagescale()). (cmb)
  . Fixed bug #76041 (null pointer access crashed php). (cmb)
  . Fixed imagesetinterpolation arginfo. (Gabriel Caruso)

- iconv:
  . Fixed bug #75867 (Freeing uninitialized pointer). (Philip Prindeville)

- Mbstring:
  . Fixed bug #62545 (wrong unicode mapping in some charsets). (cmb)

- Opcache:
  . Fixed bug #75969 (Assertion failure in live range DCE due to block pass
    misoptimization). (Nikita)

- OpenSSL:
  . Fixed openssl_* arginfos. (carusogabriel)

- PCNTL:
  . Fixed bug #75873 (pcntl_wexitstatus returns incorrect on Big_Endian platform
    (s390x)). (Sam Ding)

- Phar:
  . Fixed bug #76085 (Segmentation fault in buildFromIterator when directory
    name contains a \n). (Laruence)

- Standard:
  . Fixed bug #75961 (Strange references behavior). (Laruence)
  . Fixed some arginfos. (carusogabriel)
  . Fixed bug #76068 (parse_ini_string fails to parse "[foo]\nbar=1|>baz" with
    segfault). (Anatol)

01 Mar 2018, PHP 7.2.3

- Core:
  . Fixed bug #75864 ("stream_isatty" returns wrong value on s390x). (Sam Ding)

- Apache2Handler:
  . Fixed bug #75882 (a simple way for segfaults in threadsafe php just with
    configuration). (Anatol)

- Date:
  . Fixed bug #75857 (Timezone gets truncated when formatted). (carusogabriel)
  . Fixed bug #75928 (Argument 2 for `DateTimeZone::listIdentifiers()` should
    accept `null`). (Pedro Lacerda)
  . Fixed bug #68406 (calling var_dump on a DateTimeZone object modifies it).
    (jhdxr)

- LDAP:
  . Fixed bug #49876 (Fix LDAP path lookup on 64-bit distros). (dzuelke)

- libxml2:
  . Fixed bug #75871 (use pkg-config where available). (pmmaga)

- PGSQL:
  . Fixed bug #75838 (Memory leak in pg_escape_bytea()). (ard_1 at mail dot ru)

- Phar:
  . Fixed bug #54289 (Phar::extractTo() does not accept specific directories to
    be extracted). (bishop)
  . Fixed bug #65414 (deal with leading slash while adding files correctly).
    (bishopb)
  . Fixed bug #65414 (deal with leading slash when adding files correctly).
    (bishopb)

- ODBC:
  . Fixed bug #73725 (Unable to retrieve value of varchar(max) type). (Anatol)

- Opcache:
  . Fixed bug #75729 (opcache segfault when installing Bitrix). (Nikita)
  . Fixed bug #75893 (file_get_contents $http_response_header variable bugged
    with opcache). (Nikita)
  . Fixed bug #75938 (Modulus value not stored in variable). (Nikita)

- SPL:
  . Fixed bug #74519 (strange behavior of AppendIterator). (jhdxr)

- Standard:
  . Fixed bug #75916 (DNS_CAA record results contain garbage). (Mike,
    Philip Sharp)
  . Fixed bug #75981 (Prevent reading beyond buffer start in http wrapper).
    (Stas)

01 Feb 2018, PHP 7.2.2

- Core:
  . Fixed bug #75742 (potential memleak in internal classes's static members).
    (Laruence)
  . Fixed bug #75679 (Path 260 character problem). (Anatol)
  . Fixed bug #75614 (Some non-portable == in shell scripts). (jdolecek)
  . Fixed bug #75786 (segfault when using spread operator on generator passed
    by reference). (Nikita)
  . Fixed bug #75799 (arg of get_defined_functions is optional). (carusogabriel)
  . Fixed bug #75396 (Exit inside generator finally results in fatal error).
    (Nikita)

- FCGI:
  . Fixed bug #75794 (getenv() crashes on Windows 7.2.1 when second parameter is
    false). (Anatol)

- IMAP:
  . Fixed bug #75774 (imap_append HeapCorruction). (Anatol)

- Opcache:
  . Fixed bug #75720 (File cache not populated after SHM runs full). (Dmitry)
  . Fixed bug #75687 (var 8 (TMP) has array key type but not value type).
    (Nikita, Laruence)
  . Fixed bug #75698 (Using @ crashes php7.2-fpm). (Nikita)
  . Fixed bug #75579 (Interned strings buffer overflow may cause crash).
    (Dmitry)

- PDO:
  . Fixed bug #75616 (PDO extension doesn't allow to be built shared on Darwin).
    (jdolecek)

- PDO MySQL:
  . Fixed bug #75615 (PDO Mysql module can't be built as module). (jdolecek)

- PGSQL:
  . Fixed bug #75671 (pg_version() crashes when called on a connection to
    cockroach). (magicaltux at gmail dot com)

- Readline:
  . Fixed bug #75775 (readline_read_history segfaults with empty file).
    (Anatol)

- SAPI:
  . Fixed bug #75735 ([embed SAPI] Segmentation fault in
    sapi_register_post_entry). (Laruence)

- SOAP:
  . Fixed bug #70469 (SoapClient generates E_ERROR even if exceptions=1 is
    used). (Anton Artamonov)
  . Fixed bug #75502 (Segmentation fault in zend_string_release). (Nikita)

- SPL:
  . Fixed bug #75717 (RecursiveArrayIterator does not traverse arrays by
    reference). (Nikita)
  . Fixed bug #75242 (RecursiveArrayIterator doesn't have constants from parent
    class). (Nikita)
  . Fixed bug #73209 (RecursiveArrayIterator does not iterate object
    properties). (Nikita)

- Standard:
   . Fixed bug #75781 (substr_count incorrect result). (Laruence)
   . Fixed bug #75653 (array_values don't work on empty array). (Nikita)

- Zip:
  . Display headers (buildtime) and library (runtime) versions in phpinfo
    (with libzip >= 1.3.1). (Remi)

04 Jan 2018, PHP 7.2.1

- Core:
  . Fixed bug #75573 (Segmentation fault in 7.1.12 and 7.0.26). (Laruence)
  . Fixed bug #75384 (PHP seems incompatible with OneDrive files on demand).
    (Anatol)
  . Fixed bug #75525 (Access Violation in vcruntime140.dll). (Anatol)
  . Fixed bug #74862 (Unable to clone instance when private __clone defined).
    (Daniel Ciochiu)
  . Fixed bug #75074 (php-process crash when is_file() is used with strings
    longer 260 chars). (Anatol)
  . Fixed bug #69727 (Remove timestamps from build to make it reproducible).
    (jelle van der Waa)

- CLI server:
  . Fixed bug #73830 (Directory does not exist). (Anatol)

- FPM:
  . Fixed bug #64938 (libxml_disable_entity_loader setting is shared between
    requests). (Remi)

- GD:
  . Fixed bug #75571 (Potential infinite loop in gdImageCreateFromGifCtx).
    (Christoph)

- Opcache:
  . Fixed bug #75608 ("Narrowing occurred during type inference" error).
    (Laruence, Dmitry)
  . Fixed bug #75579 (Interned strings buffer overflow may cause crash).
    (Dmitry)
  . Fixed bug #75570 ("Narrowing occurred during type inference" error).
    (Dmitry)
  . Fixed bug #75681 (Warning: Narrowing occurred during type inference,
    specific case). (Nikita)
  . Fixed bug #75556 (Invalid opcode 138/1/1). (Laruence)

- PCRE:
  . Fixed bug #74183 (preg_last_error not returning error code after error).
    (Andrew Nester)

- Phar:
  . Fixed bug #74782 (remove file name from output to avoid XSS). (stas)

- Standard:
  . Fixed bug #75511 (fread not free unused buffer). (Laruence)
  . Fixed bug #75514 (mt_rand returns value outside [$min,$max]+ on 32-bit)
    (Remi)
  . Fixed bug #75535 (Inappropriately parsing HTTP response leads to PHP
    segment fault). (Nikita)
  . Fixed bug #75409 (accept EFAULT in addition to ENOSYS as indicator
    that getrandom() is missing). (sarciszewski)
  . Fixed bug #73124 (php_ini_scanned_files() not reporting correctly).
    (John Stevenson)
  . Fixed bug #75574 (putenv does not work properly if parameter contains
    non-ASCII unicode character). (Anatol)

- Zip:
  . Fixed bug #75540 (Segfault with libzip 1.3.1). (Remi)

30 Nov 2017, PHP 7.2.0

- BCMath:
  . Fixed bug #46564 (bcmod truncates fractionals). (liborm85)

- CLI:
  . Fixed bug #74849 (Process is started as interactive shell in PhpStorm).
    (Anatol)
  . Fixed bug #74979 (Interactive shell opening instead of script execution
    with -f flag). (Anatol)

- CLI server:
  . Fixed bug #60471 (Random "Invalid request (unexpected EOF)" using a router
    script). (SammyK)

- Core:
  . Added ZEND_COUNT, ZEND_GET_CLASS, ZEND_GET_CALLED_CLASS, ZEND_GET_TYPE,
    ZEND_FUNC_NUM_ARGS, ZEND_FUNC_GET_ARGS instructions, to implement
    corresponding builtin functions. (Dmitry)
  . "Countable" interface is moved from SPL to Core. (Dmitry)
  . Added ZEND_IN_ARRAY instruction, implementing optimized in_array() builtin
    function, through hash lookup in flipped array. (Dmitry)
  . Removed IS_TYPE_IMMUTABLE (it's the same as COPYABLE & !REFCOUNTED). (Dmitry)
  . Removed the sql.safe_mode directive. (Kalle)
  . Removed support for Netware. (Kalle)
  . Renamed ReflectionClass::isIterateable() to ReflectionClass::isIterable()
    (alias original name for BC). (Sara)
  . Fixed bug #54535 (WSA cleanup executes before MSHUTDOWN). (Kalle)
  . Implemented FR #69791 (Disallow mail header injections by extra headers)
    (Yasuo)
  . Implemented FR #49806 (proc_nice() for Windows). (Kalle)
  . Fix pthreads detection when cross-compiling (ffontaine)
  . Fixed memory leaks caused by exceptions thrown from destructors. (Bob,
    Dmitry).
  . Fixed bug #73215 (uniqid() should use better random source). (Yasuo)
  . Implemented FR #72768 (Add ENABLE_VIRTUAL_TERMINAL_PROCESSING flag for
    php.exe). (Michele Locati)
  . Implemented "Convert numeric keys in object/array casts" RFC, fixes
    bugs #53838, #61655, #66173, #70925, #72254, etc. (Andrea)
  . Implemented "Deprecate and Remove Bareword (Unquoted) Strings" RFC.
    (Rowan Collins)
  . Raised minimum supported Windows versions to Windows 7/Server 2008 R2.
    (Anatol)
  . Implemented minor optimization in array_keys/array_values(). (Sara)
  . Added PHP_OS_FAMILY constant to determine on which OS we are. (Jan Altensen)
  . Fixed bug #73987 (Method compatibility check looks to original
    definition and not parent). (pmmaga)
  . Fixed bug #73991 (JSON_OBJECT_AS_ARRAY not respected). (Sara)
  . Fixed bug #74053 (Corrupted class entries on shutdown when a destructor
    spawns another object). (jim at commercebyte dot com)
  . Fixed bug #73971 (Filename got limited to MAX_PATH on Win32 when scan
    directory). (Anatol)
  . Fixed bug #72359, bug #72451, bug #73706, bug #71115 and others related
    to interned strings handling in TS builds. (Anatol, Dmitry)
  . Implemented "Trailing Commas In List Syntax" RFC for group use lists only.
    (Sammy Kaye Powers)
  . Fixed bug #74269 (It's possible to override trait property with different
    loosely-equal value). (pmmaga)
  . Fixed bug #61970 (Restraining __construct() access level in subclass gives
    a fatal error). (pmmaga)
  . Fixed bug #63384 (Cannot override an abstract method with an abstract
    method). (pmmaga, wes)
  . Fixed bug #74607 (Traits enforce different inheritance rules). (pmmaga)
  . Fixed misparsing of abstract unix domain socket names. (Sara)
  . Change PHP_OS_FAMILY value from "OSX" to "Darwin". (Sebastian, Kalle)
  . Allow loading PHP/Zend extensions by name in ini files (extension=<name>).
    (francois at tekwire dot net)
  . Added object type annotation. (brzuchal)
  . Fixed bug #74815 (crash with a combination of INI entries at startup).
    (Anatol)
  . Fixed bug #74836 (isset on zero-prefixed numeric indexes in array broken).
    (Dmitry)
  . Added new VM instuctions ISSET_ISEMPTY_CV and UNSET_CV. Previously they
    were implemented as ISSET_ISEMPTY_VAR and UNSET_VAR variants with
    ZEND_QUICK_SET flag. (Nikita, Dmitry)
  . Fixed bug #49649 (unserialize() doesn't handle changes in property
    visibility). (pmmaga)
  . Fixed #74866 (extension_dir = "./ext" now use current directory for base).
    (Francois Laupretre)
  . Implemented FR #74963 (Improved error message on fetching property of
    non-object). (Laruence)
  . Fixed Bug #75142 (buildcheck.sh check for autoconf version needs to be updated
    for v2.64). (zizzy at zizzy dot net, Remi)
  . Fixed bug #74878 (Data race in ZTS builds). (Nikita, Dmitry)
  . Fixed bug #75515 ("stream_copy_to_stream" doesn't stream anymore). (Sara)

- cURL:
  . Fixed bug #75093 (OpenSSL support not detected). (Remi)
  . Better fix for #74125 (use pkg-config instead of curl-config). (Remi)

- Date:
  . Fixed bug #55407 (Impossible to prototype DateTime::createFromFormat).
    (kelunik)
  . Implemented FR #71520 (Adding the DateTime constants to the
    DateTimeInterface interface). (Majkl578)
  . Fixed bug #75149 (redefinition of typedefs ttinfo and t1info). (Remi)
  . Fixed bug #75222 (DateInterval microseconds property always 0). (jhdxr)

- Dba:
  . Fixed bug #72885 (flatfile: dba_fetch() fails to read replaced entry).
    (Anatol)

- DOM:
  . Implement #74837 (Implement Countable for DomNodeList and DOMNamedNodeMap).
    (Andreas Treichel)

- EXIF:
  . Added support for vendor specific tags for the following formats:
    Samsung, DJI, Panasonic, Sony, Pentax, Minolta, Sigma/Foveon, AGFA,
	Kyocera, Ricoh & Epson. (Kalle)
  . Fixed bug #72682 (exif_read_data() fails to read all data for some
    images). (Kalle)
  . Fixed bug #71534 (Type confusion in exif_read_data() leading to heap
    overflow in debug mode). (hlt99 at blinkenshell dot org, Kalle)
  . Fixed bug #68547 (Exif Header component value check error).
    (sjh21a at gmail dot com, Kalle)
  . Fixed bug #66443 (Corrupt EXIF header: maximum directory nesting level
    reached for some cameras). (Kalle)
  . Fixed Redhat bug #1362571 (PHP not returning full results for
    exif_read_data function). (Kalle)
  . Implemented #65187 (exif_read_data/thumbnail: add support for stream
    resource). (Kalle)
  . Deprecated the read_exif_data() alias. (Kalle)
  . Fixed bug #74428 (exif_read_data(): "Illegal IFD size" warning occurs with
    correct exif format). (bradpiccho at gmail dot com, Kalle)
  . Fixed bug #72819 (EXIF thumbnails not read anymore). (Kalle)
  . Fixed bug #62523 (php crashes with segfault when exif_read_data called).
    (Kalle)
  . Fixed bug #50660 (exif_read_data(): Illegal IFD offset (works fine with
    other exif readers). (skinny dot bravo at gmail dot com, Kalle)

- Fileinfo:
  . Upgrade bundled libmagic to 5.31. (Anatol)

- FPM:
  . Configuration to limit fpm slow log trace callers. (Sannis)
  . Fixed bug #75212 (php_value acts like php_admin_value). (Remi)

- FTP:
  . Implement MLSD for structured listing of directories. (blar)
  . Added ftp_append() function. (blar)

- GD:
  . Implemented imageresolution as getter and setter (Christoph)
  . Fixed bug #74744 (gd.h: stdarg.h include missing for va_list use in
    gdErrorMethod). (rainer dot jung at kippdata dot de, cmb)
  . Fixed bug #75111 (Memory disclosure or DoS via crafted .bmp image). (cmb)

- GMP:
  . Fixed bug #70896 (gmp_fact() silently ignores non-integer input). (Sara)

- Hash:
  . Changed HashContext from resource to object. (Rouven Weßling, Sara)
  . Disallowed usage of non-cryptographic hash functions with HMAC and PBKDF2.
    (Andrey Andreev, Nikita)
  . Fixed Bug #75284 (sha3 is not supported on bigendian machine). (Remi)

- IMAP:
  . Fixed bug #72324 (imap_mailboxmsginfo() return wrong size).
    (ronaldpoon at udomain dot com dot hk, Kalle)

- Intl:
  . Fixed bug #63790 (test using Spoofchecker which may be unavailable). (Sara)
  . Fixed bug #75378 ([REGRESSION] IntlDateFormatter::parse() does not change
    $position argument). (Laruence)

- JSON:
  . Add JSON_INVALID_UTF8_IGNORE and JSON_INVALID_UTF8_SUBSTITUTE options for
    json_encode and json_decode to ignore or replace invalid UTF-8 byte
    sequences - it addresses request #65082. (Jakub Zelenka)
  . Fixed bug #75185 (Buffer overflow in json_decode() with
    JSON_INVALID_UTF8_IGNORE or JSON_INVALID). (Jakub Zelenka)
  . Fixed bug #68567 (JSON_PARTIAL_OUTPUT_ON_ERROR can result in JSON with null
    key). (Jakub Zelenka)

- LDAP:
  . Implemented FR #69445 (Support for LDAP EXOP operations)
  . Fixed support for LDAP_OPT_SERVER_CONTROLS and LDAP_OPT_CLIENT_CONTROLS in ldap_get_option
  . Fixed passing an empty array to ldap_set_option for client or server controls.

- Mbstring:
  . Implemented request #66024 (mb_chr() and mb_ord()). (Masakielastic, Yasuo)
  . Implemented request #65081 (mb_scrub()). (Masakielastic, Yasuo)
  . Implemented request #69086 (enhancement for mb_convert_encoding() that
    handles multibyte replacement char nicely). (Masakielastic, Yasuo)
  . Added array input support to mb_convert_encoding(). (Yasuo)
  . Added array input support to mb_check_encoding(). (Yasuo)
  . Fixed bug #69079 (enhancement for mb_substitute_character). (masakielastic)
  . Update to oniguruma version 6.3.0. (Remi)
  . Fixed bug #69267 (mb_strtolower fails on titlecase characters). (Nikita)

- Mcrypt:
  . The deprecated mcrypt extension has been moved to PECL. (leigh)

- Opcache:
  . Added global optimisation passes based on data flow analysis using Single
    Static Assignment (SSA) form: Sparse Conditional Constant Propagation (SCCP),
    Dead Code Elimination (DCE), and removal of unused local variables
    (Nikita, Dmitry)
  . Fixed incorect constant conditional jump elimination. (Dmitry)
  . Fixed bug #75230 (Invalid opcode 49/1/8 using opcache). (Laruence)
  . Fixed bug (assertion fails with extended info generated). (Laruence)
  . Fixed bug (Phi sources removel). (Laruence)
  . Fixed bug #75370 (Webserver hangs on valid PHP text). (Laruence)
  . Fixed bug #75357 (segfault loading WordPress wp-admin). (Laruence)

- OpenSSL:
  . Use TLS_ANY for default ssl:// and tls:// negotiation. (kelunik)
  . Fix leak in openssl_spki_new(). (jelle at vdwaa dot nl)
  . Added openssl_pkcs7_read() and pk7 parameter to openssl_pkcs7_verify().
    (jelle at vdwaa dot nl)
  . Add ssl security_level stream option to support OpenSSL security levels.
    (Jakub Zelenka).
  . Allow setting SNI cert and private key in separate files. (Jakub Zelenka)
  . Fixed bug #74903 (openssl_pkcs7_encrypt() uses different EOL than before).
    (Anatol)
  . Automatically load OpenSSL configuration file. (Jakub Zelenka)

- PCRE:
  . Added support for PCRE JIT fast path API. (dmitry)
  . Fixed bug #61780 (Inconsistent PCRE captures in match results). (cmb)
  . Fixed bug #74873 (Minor BC break: PCRE_JIT changes output of preg_match()).
    (Dmitry)
  . Fixed bug #75089 (preg_grep() is not reporting PREG_BAD_UTF8_ERROR after
    first input string). (Dmitry)
  . Fixed bug #75223 (PCRE JIT broken in 7.2). (Dmitry)
  . Fixed bug #75285 (Broken build when system libpcre don't have jit support).
    (Remi)

- phar:
  . Fixed bug #74196 (phar does not correctly handle names containing dots).
    (mhagstrand)

- PDO:
  . Add "Sent SQL" to debug dump for emulated prepares. (Adam Baratz)
  . Add parameter types for national character set strings. (Adam Baratz)

- PDO_DBlib:
  . Fixed bug #73234 (Emulated statements let value dictate parameter type).
    (Adam Baratz)
  . Fixed bug #73396 (bigint columns are returned as strings). (Adam Baratz)
  . Expose DB-Library version as \PDO::DBLIB_ATTR_VERSION attribute on \PDO
    instance. (Adam Baratz)
  . Add test coverage for bug #72969. (Jeff Farr)

- PDO_OCI:
  . Fixed Bug #74537 (Align --with-pdo-oci configure option with --with-oci8 syntax).
    (Tianfang Yang)

- PDO_Sqlite
  . Switch to sqlite3_prepare_v2() and sqlite3_close_v2() functions (rasmus)

- PHPDBG
  . Added extended_value to opcode dump output. (Sara)

- Session:
  . Fixed bug #73461 (Prohibit session save handler recursion). (Yasuo)
  . PR #2233 Removed register_globals related code and "!" can be used as $_SESSION key name. (Yasuo)
  . Improved bug #73100 fix. 'user' save handler can only be set by session_set_save_handler()
  . Fixed bug #74514 (5 session functions incorrectly warn when calling in
    read-only/getter mode). (Yasuo)
  . Fixed bug #74936 (session_cache_expire/cache_limiter/save_path() trigger a
    warning in read mode). (morozov)
  . Fixed bug #74941 (session fails to start after having headers sent).
    (morozov)

- Sodium:
  . New cryptographic extension
  . Added missing bindings for libsodium > 1.0.13. (Frank)

- SPL:
  . Fixed bug #71412 (Incorrect arginfo for ArrayIterator::__construct).
    (tysonandre775 at hotmail dot com)
  . Added spl_object_id(). (Tyson Andre)

- SQLite3:
  . Implement writing to blobs. (bohwaz at github dot com)
  . Update to Sqlite 3.20.1. (cmb)

- Standard:
  . Fixed bug #69442 (closing of fd incorrect when PTS enabled). (jaytaph)
  . Fixed bug #74300 (unserialize accepts two plus/minus signs for float number exponent part).
    (xKerman)
  . Compatibility with libargon2 versions 20161029 and 20160821.
    (charlesportwoodii at erianna dot com)
  . Fixed Bug #74737 (mysqli_get_client_info reflection info).
    (mhagstrand at gmail dot com)
  . Add support for extension name as argument to dl().
    (francois at tekwire dot net)
  . Fixed bug #74851 (uniqid() without more_entropy performs badly).
    (Emmanuel Dreyfus)
  . Fixed bug #74103 (heap-use-after-free when unserializing invalid array
    size). (Nikita)
  . Fixed bug #75054 (A Denial of Service Vulnerability was found when
    performing deserialization). (Nikita)
  . Fixed bug #75170 (mt_rand() bias on 64-bit machines). (Nikita)
  . Fixed bug #75221 (Argon2i always throws NUL at the end). (cmb)

- Streams:
  . Default ssl/single_dh_use and ssl/honor_cipher_order to true. (kelunik)

- XML:
  . Moved utf8_encode() and utf8_decode() to the Standard extension. (Andrea)

- XMLRPC:
  . Use Zend MM for allocation in bundled libxmlrpc (Joe)

- ZIP:
  . Add support for encrypted archives. (Remi)
  . Use of bundled libzip is deprecated, --with-libzip option is recommended. (Remi)
  . Fixed Bug #73803 (Reflection of ZipArchive does not show public properties). (Remi)
  . ZipArchive implements countable, added ZipArchive::count() method. (Remi)
  . Fix segfault in php_stream_context_get_option call. (Remi)
  . Fixed bug #75143 (new method setEncryptionName() seems not to exist
    in ZipArchive). (Anatol)

- zlib:
  . Expose inflate_get_status() and inflate_get_read_len() functions.
    (Matthew Trescott)

23 Nov 2017, PHP 7.1.12

- Core:
  . Fixed bug #75420 (Crash when modifing property name in __isset for
    BP_VAR_IS). (Laruence)
  . Fixed bug #75368 (mmap/munmap trashing on unlucky allocations). (Nikita,
    Dmitry)

- CLI:
  . Fixed bug #75287 (Builtin webserver crash after chdir in a shutdown
    function). (Laruence)

- Enchant:
  . Fixed bug #53070 (enchant_broker_get_path crashes if no path is set). (jelle
    van der Waa, cmb)
  . Fixed bug #75365 (Enchant still reports version 1.1.0). (cmb)

- Exif:
  . Fixed bug #75301 (Exif extension has built in revision version). (Peter
    Kokot)

- GD:
  . Fixed bug #65148 (imagerotate may alter image dimensions). (cmb)
  . Fixed bug #75437 (Wrong reflection on imagewebp). (Fabien Villepinte)

- intl:
  . Fixed bug #75317 (UConverter::setDestinationEncoding changes source instead
    of destination). (andrewnester)

- interbase:
  . Fixed bug #75453 (Incorrect reflection for ibase_[p]connect). (villfa)

- Mysqli:
  . Fixed bug #75434 (Wrong reflection for mysqli_fetch_all function). (Fabien
    Villepinte)

- OCI8:
  . Fixed valgrind issue. (Tianfang Yang)

- OpenSSL:
  . Fixed bug #75363 (openssl_x509_parse leaks memory). (Bob, Jakub Zelenka)
  . Fixed bug #75307 (Wrong reflection for openssl_open function). (villfa)

- Opcache:
  . Fixed bug #75373 (Warning Internal error: wrong size calculation). (Laruence, Dmitry)

- PGSQL:
  . Fixed bug #75419 (Default link incorrectly cleared/linked by pg_close()). (Sara)

- SOAP:
  . Fixed bug #75464 (Wrong reflection on SoapClient::__setSoapHeaders). (villfa)

- Zlib:
  . Fixed bug #75299 (Wrong reflection on inflate_init and inflate_add). (Fabien
    Villepinte)

26 Oct 2017, PHP 7.1.11

- Core:
  . Fixed bug #75241 (Null pointer dereference in zend_mm_alloc_small()).
    (Laruence)
  . Fixed bug #75236 (infinite loop when printing an error-message). (Andrea)
  . Fixed bug #75252 (Incorrect token formatting on two parse errors in one
    request). (Nikita)
  . Fixed bug #75220 (Segfault when calling is_callable on parent).
    (andrewnester)
  . Fixed bug #75290 (debug info of Closures of internal functions contain
    garbage argument names). (Andrea)

- Apache2Handler:
  . Fixed bug #75311 (error: 'zend_hash_key' has no member named 'arKey' in
    apache2handler). (mcarbonneaux)

- Date:
  . Fixed bug #75055 (Out-Of-Bounds Read in timelib_meridian()). (Derick)

- Hash:
  . Fixed bug #75303 (sha3 hangs on bigendian). (Remi)

- Intl:
  . Fixed bug #75318 (The parameter of UConverter::getAliases() is not
    optional). (cmb)

- litespeed:
  . Fixed bug #75248 (Binary directory doesn't get created when building
    only litespeed SAPI). (petk)
  . Fixed bug #75251 (Missing program prefix and suffix). (petk)

- mcrypt:
  . Fixed bug #72535 (arcfour encryption stream filter crashes php). (Leigh)

- MySQLi:
  . Fixed bug #75018 (Data corruption when reading fields of bit type). (Anatol)

- OCI8:
  . Fixed incorrect reference counting. (Dmitry, Tianfang Yang)

- Opcache
  . Fixed bug #75255 (Request hangs and not finish). (Dmitry)

- PCRE:
  . Fixed bug #75207 (applied upstream patch for CVE-2016-1283). (Anatol)

- PDO_mysql:
  . Fixed bug #75177 (Type 'bit' is fetched as unexpected string). (Anatol)

- SPL:
  . Fixed bug #73629 (SplDoublyLinkedList::setIteratorMode masks intern flags).
    (J. Jeising, cmb)

28 Sep 2017, PHP 7.1.10

- Core:
  . Fixed bug #75042 (run-tests.php issues with EXTENSION block). (John Boehr)

- BCMath:
  . Fixed bug #44995 (bcpowmod() fails if scale != 0). (cmb)
  . Fixed bug #46781 (BC math handles minus zero incorrectly). (cmb)
  . Fixed bug #54598 (bcpowmod() may return 1 if modulus is 1). (okano1220, cmb)
  . Fixed bug #75178 (bcpowmod() misbehaves for non-integer base or modulus). (cmb)

- CLI server:
  . Fixed bug #70470 (Built-in server truncates headers spanning over TCP
    packets). (bouk)

- CURL:
  . Fixed bug #75093 (OpenSSL support not detected). (Remi)

- GD:
  . Fixed bug #75124 (gdImageGrayScale() may produce colors). (cmb)
  . Fixed bug #75139 (libgd/gd_interpolation.c:1786: suspicious if ?). (cmb)

- Gettext:
  . Fixed bug #73730 (textdomain(null) throws in strict mode). (cmb)

- Intl:
  . Fixed bug #75090 (IntlGregorianCalendar doesn't have constants from parent
    class). (tpunt)
  . Fixed bug #75193 (segfault in collator_convert_object_to_string). (Remi)

- PDO_OCI:
  . Fixed bug #74631 (PDO_PCO with PHP-FPM: OCI environment initialized
    before PHP-FPM sets it up). (Ingmar Runge)

- SPL:
  . Fixed bug #75155 (AppendIterator::append() is broken when appending another
    AppendIterator). (Nikita)
  . Fixed bug #75173 (incorrect behavior of AppendIterator::append in foreach loop).
    (jhdxr)

- Standard:
  . Fixed bug #75152 (signed integer overflow in parse_iv). (Laruence)
  . Fixed bug #75097 (gethostname fails if your host name is 64 chars long). (Andrea)

31 Aug 2017, PHP 7.1.9

- Core:
  . Fixed bug #74947 (Segfault in scanner on INF number). (Laruence)
  . Fixed bug #74954 (null deref and segfault in zend_generator_resume()). (Bob)
  . Fixed bug #74725 (html_errors=1 breaks unhandled exceptions). (Andrea)
  . Fixed bug #75063 (Main CWD initialized with wrong codepage). (Anatol)
  . Fixed bug #75349 (NAN comparison). (Sara)

- cURL:
  . Fixed bug #74125 (Fixed finding CURL on systems with multiarch support).
    (cebe)

- Date:
  . Fixed bug #75002 (Null Pointer Dereference in timelib_time_clone). (Derick)

- Intl:
  . Fixed bug #74993 (Wrong reflection on some locale_* functions). (Sara)

- Mbstring:
  . Fixed bug #71606 (Segmentation fault mb_strcut with HTML-ENTITIES encoding).
    (cmb)
  . Fixed bug #62934 (mb_convert_kana() does not convert iteration marks).
    (Nikita)
  . Fixed bug #75001 (Wrong reflection on mb_eregi_replace). (Fabien
    Villepinte)

- MySQLi:
  . Fixed bug #74968 (PHP crashes when calling mysqli_result::fetch_object with
    an abstract class). (Anatol)

- OCI8:
  . Expose oci_unregister_taf_callback() (Tianfang Yang)

- Opcache:
  . Fixed bug #74980 (Narrowing occurred during type inference). (Laruence)

- phar:
  . Fixed bug #74991 (include_path has a 4096 char limit in some cases).
    (bwbroersma)

- Reflection:
  . Fixed bug #74949 (null pointer dereference in _function_string). (Laruence)

- Session:
  . Fixed bug #74892 (Url Rewriting (trans_sid) not working on urls that start
    with "#"). (Andrew Nester)
  . Fixed bug #74833 (SID constant created with wrong module number). (Anatol)

- SimpleXML:
  . Fixed bug #74950 (nullpointer deref in simplexml_element_getDocNamespaces).
    (Laruence)

- SPL:
  . Fixed bug #75049 (spl_autoload_unregister can't handle
    spl_autoload_functions results). (Laruence)
  . Fixed bug #74669 (Unserialize ArrayIterator broken). (Andrew Nester)
  . Fixed bug #74977 (Appending AppendIterator leads to segfault).
    (Andrew Nester)
  . Fixed bug #75015 (Crash in recursive iterator destructors). (Julien)

- Standard:
  . Fixed bug #75075 (unpack with X* causes infinity loop). (Laruence)
  . Fixed bug #74103 (heap-use-after-free when unserializing invalid array
    size). (Nikita)
  . Fixed bug #75054 (A Denial of Service Vulnerability was found when
    performing deserialization). (Nikita)

- WDDX:
  . Fixed bug #73793 (WDDX uses wrong decimal seperator). (cmb)

- XMLRPC:
  . Fixed bug #74975 (Incorrect xmlrpc serialization for classes with declared
    properties). (blar)

03 Aug 2017, PHP 7.1.8

- Core:
  . Fixed bug #74832 (Loading PHP extension with already registered function
    name leads to a crash). (jpauli)
  . Fixed bug #74780 (parse_url() broken when query string contains colon).
    (jhdxr)
  . Fixed bug #74761 (Unary operator expected error on some systems). (petk)
  . Fixed bug #73900 (Use After Free in unserialize() SplFixedArray). (nikic)
  . Fixed bug #74923 (Crash when crawling through network share). (Anatol)
  . Fixed bug #74913 (fixed incorrect poll.h include). (petk)
  . Fixed bug #74906 (fixed incorrect errno.h include). (petk)

- Date:
  . Fixed bug #74852 (property_exists returns true on unknown DateInterval
    property). (jhdxr)

- OCI8:
  . Fixed bug #74625 (Integer overflow in oci_bind_array_by_name). (Ingmar Runge)

- Opcache:
  . Fixed bug #74623 (Infinite loop in type inference when using HTMLPurifier).
    (nikic)

- OpenSSL:
 . Fixed bug #74798 (pkcs7_en/decrypt does not work if \x0a is used in content).
   (Anatol)
 . Added OPENSSL_DONT_ZERO_PAD_KEY constant to prevent key padding and fix bug
   #71917 (openssl_open() returns junk on envelope < 16 bytes) and bug #72362
   (OpenSSL Blowfish encryption is incorrect for short keys). (Jakub Zelenka)

- PDO:
  . Fixed bug #69356 (PDOStatement::debugDumpParams() truncates query). (Adam
    Baratz)

- SPL:
  . Fixed bug #73471 (PHP freezes with AppendIterator). (jhdxr)

- SQLite3:
  . Fixed bug #74883 (SQLite3::__construct() produces "out of memory" exception
    with invalid flags). (Anatol)

- Wddx:
  . Fixed bug #73173 (huge memleak when wddx_unserialize).
    (tloi at fortinet dot com)

- zlib:
  . Fixed bug #73944 (dictionary option of inflate_init() does not work).
    (wapmorgan)

06 Jul 2017, PHP 7.1.7

- Core:
  . Fixed bug #74738 (Multiple [PATH=] and [HOST=] sections not properly
    parsed). (Manuel Mausz)
  . Fixed bug #74658 (Undefined constants in array properties result in broken
    properties). (Laruence)
  . Fixed misparsing of abstract unix domain socket names. (Sara)
  . Fixed bug #74603 (PHP INI Parsing Stack Buffer Overflow Vulnerability).
    (Stas)
  . Fixed bug #74101, bug #74614 (Unserialize Heap Use-After-Free (READ: 1) in
    zval_get_type). (Nikita)
  . Fixed bug #74111 (Heap buffer overread (READ: 1) finish_nested_data from
    unserialize). (Nikita)
  . Fixed bug #74819 (wddx_deserialize() heap out-of-bound read via
    php_parse_date()). (Derick)

- Date:
  . Fixed bug #74639 (implement clone for DatePeriod and DateInterval).
    (andrewnester)

- DOM:
  . Fixed bug #69373 (References to deleted XPath query results). (ttoohey)

- GD:
  . Fixed bug #74435 (Buffer over-read into uninitialized memory). (cmb)

- Intl:
  . Fixed bug #73473 (Stack Buffer Overflow in msgfmt_parse_message). (libnex)
  . Fixed bug #74705 (Wrong reflection on Collator::getSortKey and
    collator_get_sort_key). (Tyson Andre, Remi)

- Mbstring:
  . Add oniguruma upstream fix (CVE-2017-9224, CVE-2017-9226, CVE-2017-9227,
    CVE-2017-9228, CVE-2017-9229) (Remi, Mamoru TASAKA)

- OCI8:
  . Add TAF callback (PR #2459). (KoenigsKind)

- Opcache:
  . Fixed bug #74663 (Segfault with opcache.memory_protect and
    validate_timestamp). (Laruence)
  . Revert opcache.enable_cli to default disabled. (Nikita)

- OpenSSL:
  . Fixed bug #74720 (pkcs7_en/decrypt does not work if \x1a is used in
    content). (Anatol)
  . Fixed bug #74651 (negative-size-param (-1) in memcpy in zif_openssl_seal()).
    (Stas)

- PDO_OCI:
  . Support Instant Client 12.2 in --with-pdo-oci configure option.
    (Tianfang Yang)

- Reflection:
  . Fixed bug #74673 (Segfault when cast Reflection object to string with
    undefined constant). (Laruence)

- SPL:
  . Fixed bug #74478 (null coalescing operator failing with SplFixedArray).
    (jhdxr)

- FTP:
  . Fixed bug #74598 (ftp:// wrapper ignores context arg). (Sara)

- PHAR:
  . Fixed bug #74386 (Phar::__construct reflection incorrect). (villfa)

- SOAP
  . Fixed bug #74679 (Incorrect conversion array with WSDL_CACHE_MEMORY).
    (Dmitry)

- Streams:
  . Fixed bug #74556 (stream_socket_get_name() returns '\0'). (Sara)

8 Jun 2017, PHP 7.1.6

- Core:
  . Fixed bug #74600 (crash (SIGSEGV) in _zend_hash_add_or_update_i).
    (Laruence)
  . Fixed bug #74546 (SIGILL in ZEND_FETCH_CLASS_CONSTANT_SPEC_CONST_CONST).
    (Laruence)
  . Fixed bug #74589 (__DIR__ wrong for unicode character). (Anatol)

- intl:
  . Fixed bug #74468 (wrong reflection on Collator::sortWithSortKeys). (villfa)

- MySQLi:
  . Fixed bug #74547 (mysqli::change_user() doesn't accept null as $database
    argument w/strict_types). (Anatol)

- Opcache:
  . Fixed bug #74596 (SIGSEGV with opcache.revalidate_path enabled). (Laruence)

- phar:
  . Fixed bug #51918 (Phar::webPhar() does not handle requests sent through PUT
    and DELETE method). (Christian Weiske)

- Readline:
  . Fixed bug #74490 (readline() moves the cursor to the beginning of the line).
    (Anatol)

- Standard:
  . Fixed bug #74510 (win32/sendmail.c anchors CC header but not BCC).
    (Damian Wadley, Anatol)

- xmlreader:
  . Fixed bug #74457 (Wrong reflection on XMLReader::expand). (villfa)

11 May 2017, PHP 7.1.5

- Core:
  . Fixed bug #74408 (Endless loop bypassing execution time limit). (Laruence)
  . Fixed bug #74353 (Segfault when killing within bash script trap code).
    (Laruence)
  . Fixed bug #74340 (Magic function __get has different behavior in php 7.1.x).
    (Nikita)
  . Fixed bug #74188 (Null coalescing operator fails for undeclared static
    class properties). (tpunt)
  . Fixed bug #74444 (multiple catch freezes in some cases). (David Matějka)
  . Fixed bug #74410 (stream_select() is broken on Windows Nanoserver).
    (Matt Ficken)
  . Fixed bug #74337 (php-cgi.exe crash on facebook callback).
    (Anton Serbulov)
  . Patch for bug #74216 was reverted. (Anatol)

- Date:
  . Fixed bug #74404 (Wrong reflection on DateTimeZone::getTransitions).
    (krakjoe)
  . Fixed bug #74080 (add constant for RFC7231 format datetime). (duncan3dc)

- DOM:
  . Fixed bug #74416 (Wrong reflection on DOMNode::cloneNode).
    (Remi, Fabien Villepinte)

- Fileinfo:
  . Fixed bug #74379 (syntax error compile error in libmagic/apprentice.c).
    (Laruence)

- GD:
  . Fixed bug #74343 (compile fails on solaris 11 with system gd2 library).
    (krakjoe)

- MySQLi:
  . Fixed bug #74432 (mysqli_connect adding ":3306" to $host if $port parameter
    not given). (Anatol)

- MySQLnd:
  . Fixed bug #74376 (Invalid free of persistent results on error/connection
    loss). (Yussuf Khalil)

- Intl:
  . Fixed bug #65683 (Intl does not support DateTimeImmutable). (Ben Scholzen)
  . Fixed bug #74298 (IntlDateFormatter->format() doesn't return
    microseconds/fractions). (Andrew Nester)
  . Fixed bug #74433 (wrong reflection for Normalizer methods). (villfa)
  . Fixed bug #74439 (wrong reflection for Locale methods). (villfa)

- Opcache:
  . Fixed bug #74456 (Segmentation error while running a script in CLI mode).
    (Laruence)
  . Fixed bug #74431 (foreach infinite loop). (Nikita)
  . Fixed bug #74442 (Opcached version produces a nested array). (Nikita)

- OpenSSL:
  . Fixed bug #73833 (null character not allowed in openssl_pkey_get_private).
    (Jakub Zelenka)
  . Fixed bug #73711 (Segfault in openssl_pkey_new when generating DSA or DH
    key). (Jakub Zelenka)
  . Fixed bug #74341 (openssl_x509_parse fails to parse ASN.1 UTCTime without
    seconds). (Moritz Fain)
  . Fixed bug #73808 (iv length warning too restrictive for aes-128-ccm).
    (Jakub Zelenka)

- phar:
  . Fixed bug #74383 (phar method parameters reflection correction).
    (mhagstrand)

- Readline:
  . Fixed bug #74489 (readline() immediately returns false in interactive
    console mode). (Anatol)

- Standard:
  . Fixed bug #72071 (setcookie allows max-age to be negative). (Craig Duncan)
  . Fixed bug #74361 (Compaction in array_rand() violates COW). (Nikita)

- Streams:
  . Fixed bug #74429 (Remote socket URI with unique persistence identifier
    broken). (Sara)

13 Apr 2017, PHP 7.1.4

- Core:
  . Fixed bug #74149 (static embed SAPI linkage error). (krakjoe)
  . Fixed bug #73370 (falsely exits with "Out of Memory" when using
    USE_ZEND_ALLOC=0). (Nikita)
  . Fixed bug #73960 (Leak with instance method calling static method with
    referenced return). (Nikita)
  . Fixed bug #69676 (Resolution of self::FOO in class constants not correct).
    (Nikita)
  . Fixed bug #74265 (Build problems after 7.0.17 release: undefined reference
    to `isfinite'). (Nikita)
  . Fixed bug #74302 (yield fromLABEL is over-greedy). (Sara)

- Apache:
  . Reverted patch for bug #61471, fixes bug #74318. (Anatol)

- Date:
  . Fixed bug #72096 (Swatch time value incorrect for dates before 1970). (mcq8)

- DOM:
  . Fixed bug #74004 (LIBXML_NOWARNING flag ingnored on loadHTML*).
    (somedaysummer)

- iconv:
  . Fixed bug #74230 (iconv fails to fail on surrogates). (Anatol)

- OCI8:
  . Fixed uninitialized data causing random crash. (Dmitry)

- Opcache:
  . Fixed bug #74250 (OPcache compilation performance regression in PHP 5.6/7
    with huge classes). (Nikita)

- OpenSSL:
  . Fixed bug #72333 (fwrite() on non-blocking SSL sockets doesn't work).
    (Jakub Zelenka)

- PDO MySQL:
  . Fixed bug #71003 (Expose MYSQLI_CLIENT_SSL_DONT_VERIFY_SERVER_CERT to PDO
    interface). (Thomas Orozco)

- SPL:
  . Fixed bug #74058 (ArrayObject can not notice changes). (Andrew Nester)

- Sqlite:
  . Implemented FR #74217 (Allow creation of deterministic sqlite functions).
    (Andrew Nester)

- Streams:
  . Fixed bug #74216 (Correctly fail on invalid IP address ports). (Sara)

- Zlib:
  . Fixed bug #74240 (deflate_add can allocate too much memory). (Matt Bonneau)

16 Mar 2017, PHP 7.1.3

- Core:
  . Fixed bug #74157 (Segfault with nested generators). (Laruence)
  . Fixed bug #74164 (PHP hangs when an invalid value is dynamically passed to
    typehinted by-ref arg). (Laruence)
  . Fixed bug #74093 (Maximum execution time of n+2 seconds exceed not written
    in error_log). (Laruence)
  . Fixed bug #73989 (PHP 7.1 Segfaults within Symfony test suite).
    (Dmitry, Laruence)
  . Fixed bug #74084 (Out of bound read - zend_mm_alloc_small). (Laruence)
  . Fixed bug #73807 (Performance problem with processing large post request).
    (Nikita)
  . Fixed bug #73998 (array_key_exists fails on arrays created by
    get_object_vars). (mhagstrand)
  . Fixed bug #73954 (NAN check fails on Alpine Linux with musl). (Andrea)
  . Fixed bug #73677 (Generating phar.phar core dump with gcc ASAN enabled
    build). (ondrej)

- Apache:
  . Fixed bug #61471 (Incomplete POST does not timeout but is passed to PHP).
    (Zheng Shao)

- Date:
  . Fixed bug #73837 ("new DateTime()" sometimes returns 1 second ago value).
    (Derick)

- FPM:
  . Fixed bug #69860 (php-fpm process accounting is broken with keepalive).
    (Denis Yeldandi)

- Hash:
  . Fixed bug #73127 (gost-crypto hash incorrect if input data contains long
    0xFF sequence). (Grundik)

- GD:
  . Fixed bug #74031 (ReflectionFunction for imagepng is missing last two
    parameters). (finwe)

- Mysqlnd:
  . Fixed bug #74021 (fetch_array broken data. Data more then MEDIUMBLOB).
    (Andrew Nester, Nikita)

- Opcache:
  . Fixed bug #74152 (if statement says true to a null variable). (Laruence)
  . Fixed bug #74019 (Segfault with list). (Laruence)

- OpenSSL:
  . Fixed bug #74022 (PHP Fast CGI crashes when reading from a pfx file).
    (Anatol)
  . Fixed bug #74099 (Memory leak with openssl_encrypt()). (Andrew Nester)
  . Fixed bug #74159 (Writing a large buffer to a non-blocking encrypted stream
    fails with "bad write retry"). (trowski)

- PDO_OCI:
  . Fixed bug #54379 (PDO_OCI: UTF-8 output gets truncated). (gureedo / Oracle)

- SQLite3:
  . Fixed bug #74413 (incorrect reflection for SQLite3::enableExceptions).
    (krakjoe)

- Standard:
  . Fixed bug #74005 (mail.add_x_header causes RFC-breaking lone line feed).
    (Anatol)
  . Fixed bug #74041 (substr_count with length=0 broken). (Nikita)
  . Fixed bug #73118 (is_callable callable name reports misleading value for
    anonymous classes). (Adam Saponara)
  . Fixed bug #74105 (PHP on Linux should use /dev/urandom when getrandom is
    not available). (Benjamin Robin)
  . Fixed bug #74708 (Invalid Reflection signatures for random_bytes and
    random_int). (Tyson Andre, Remi)

- Streams:
  . Fixed bug #73496 (Invalid memory access in zend_inline_hash_func).
    (Laruence)
  . Fixed bug #74090 (stream_get_contents maxlength>-1 returns empty string).
    (Anatol)

16 Feb 2017, PHP 7.1.2

- Core:
  . Improved GENERATOR_CREATE opcode handler. (Bob, Dmitry)
  . Fixed bug #73877 (readlink() returns garbage for UTF-8 paths). (Anatol)
  . Fixed bug #73876 (Crash when exporting **= in expansion of assign op).
    (Sara)
  . Fixed bug #73962 (bug with symlink related to cyrillic directory). (Anatol)
  . Fixed bug #73969 (segfault in debug_print_backtrace). (andrewnester)
  . Fixed bug #73994 (arginfo incorrect for unpack). (krakjoe)
  . Fixed bug #73973 (assertion error in debug_zval_dump). (andrewnester)

- DOM:
  . Fixed bug #54382 (getAttributeNodeNS doesn't get xmlns* attributes).
    (aboks)

- DTrace:
  . Fixed bug #73965 (DTrace reported as enabled when disabled). (Remi)

- FCGI:
  . Fixed bug #73904 (php-cgi fails to load -c specified php.ini file). (Anatol)
  . Fixed bug #72898 (PHP_FCGI_CHILDREN is not included in phpinfo()). (Anatol)

- FPM:
  . Fixed bug #69865 (php-fpm does not close stderr when using syslog).
    (m6w6)

- GD:
  . Fixed bug #73968 (Premature failing of XBM reading). (cmb)

- GMP:
  . Fixed bug #69993 (test for gmp.h needs to test machine includes).
    (Jordan Gigov)

- Hash:
  . Added hash_hkdf() function. (Andrey Andreev)
  . Fixed bug #73961 (environmental build dependency in hash sha3 source).
    (krakjoe)

- Intl:
  . Fix bug #73956 (Link use CC instead of CXX). (Remi)

- LDAP:
  . Fixed bug #73933 (error/segfault with ldap_mod_replace and opcache).
    (Laruence)

- MySQLi:
  . Fixed bug #73949 (leak in mysqli_fetch_object). (krakjoe)

- Mysqlnd:
  . Fixed bug #69899 (segfault on close() after free_result() with mysqlnd).
    (Richard Fussenegger)

- Opcache:
  . Fixed bug #73983 (crash on finish work with phar in cli + opcache).
    (Anatol)

- OpenSSL:
  . Fixed bug #71519 (add serial hex to return value array). (xrobau)
  . Fixed bug #73692 (Compile ext/openssl with openssl 1.1.0 on Win). (Anatol)
  . Fixed bug #73978 (openssl_decrypt triggers bug in PDO). (Jakub Zelenka)

- PDO_Firebird:
  . Implemented FR #72583 (All data are fetched as strings). (Dorin Marcoci)

- PDO_PgSQL:
  . Fixed bug #73959 (lastInsertId fails to throw an exception for wrong
    sequence name). (andrewnester)

- Phar:
  . Fixed bug #70417 (PharData::compress() doesn't close temp file). (cmb)

- posix:
  . Fixed bug #71219 (configure script incorrectly checks for ttyname_r). (atoh)

- Session:
  . Fixed bug #69582 (session not readable by root in CLI). (EvgeniySpinov)

- SPL:
  . Fixed bug #73896 (spl_autoload() crashes when calls magic _call()). (Dmitry)

- Standard:
  . Fixed bug #69442 (closing of fd incorrect when PTS enabled). (jaytaph)
  . Fixed bug #47021 (SoapClient stumbles over WSDL delivered with
    "Transfer-Encoding: chunked"). (Rowan Collins)
  . Fixed bug #72974 (imap is undefined service on AIX). (matthieu.sarter)
  . Fixed bug #72979 (money_format stores wrong length AIX). (matthieu.sarter)
  . Fixed bug #73374 (intval() with base 0 should detect binary). (Leigh)
  . Fixed bug #69061 (mail.log = syslog contains double information).
    (Tom Sommer)

- ZIP:
  . Fixed bug #70103 (ZipArchive::addGlob ignores remove_all_path option). (cmb,
    Mitch Hagstrand)

19 Jan 2017, PHP 7.1.1

- Core:
  . Fixed bug #73792 (invalid foreach loop hangs script). (Dmitry)
  . Fixed bug #73686 (Adding settype()ed values to ArrayObject results in
    references). (Nikita, Laruence)
  . Fixed bug #73663 ("Invalid opcode 65/16/8" occurs with a variable created
    with list()). (Laruence)
  . Fixed bug #73727 (ZEND_MM_BITSET_LEN is "undefined symbol" in
    zend_bitset.h). (Nikita)
  . Fixed bug #73753 (unserialized array pointer not advancing). (David Walker)
  . Fixed bug #73783 (SIG_IGN doesn't work when Zend Signals is enabled).
    (David Walker)

- CLI:
  . Fixed bug #72555 (CLI output(japanese) on Windows). (Anatol)

- COM:
  . Fixed bug #73679 (DOTNET read access violation using invalid codepage).
    (Anatol)

- DOM:
  . Fixed bug #67474 (getElementsByTagNameNS filter on default ns). (aboks)

- Mbstring:
  . Fixed bug #73646 (mb_ereg_search_init null pointer dereference).
    (Laruence)

- Mysqli:
  . Fixed bug #73462 (Persistent connections don't set $connect_errno).
    (darkain)

- Mysqlnd:
  . Optimized handling of BIT fields - less memory copies and lower memory
    usage. (Andrey)
  . Fixed bug #73800 (sporadic segfault with MYSQLI_OPT_INT_AND_FLOAT_NATIVE).
	(vanviegen)

- Opcache:
  . Fixed bug #73789 (Strange behavior of class constants in switch/case block).
    (Laruence)
  . Fixed bug #73746 (Method that returns string returns UNKNOWN:0 instead).
    (Laruence)
  . Fixed bug #73654 (Segmentation fault in zend_call_function). (Nikita)
  . Fixed bug #73668 ("SIGFPE Arithmetic exception" in opcache when divide by
    minus 1). (Nikita)
  . Fixed bug #73847 (Recursion when a variable is redefined as array). (Nikita)

- PDO_Firebird:
  . Fixed bug #72931 (PDO_FIREBIRD with Firebird 3.0 not work on returning
    statement). (Dorin Marcoci)

- phpdbg:
  . Fixed bug #73794 (Crash (out of memory) when using run and # command
    separator). (Bob)
  . Fixed bug #73704 (phpdbg shows the wrong line in files with shebang). (Bob)

- SQLite3:
  . Reverted fix for bug #73530	(Unsetting result set may reset other result
    set). (cmb)

- Standard:
  . Fixed bug #73594 (dns_get_record does not populate $additional out
    parameter). (Bruce Weirdan)
  . Fixed bug #70213 (Unserialize context shared on double class lookup).
    (Taoguang Chen)
  . Fixed bug #73154 (serialize object with __sleep function crash). (Nikita)
  . Fixed bug #70490 (get_browser function is very slow). (Nikita)
  . Fixed bug #73265 (Loading browscap.ini at startup causes high memory usage).
    (Nikita)
  . Add subject to mail log. (tomsommer)
  . Fixed bug #31875 (get_defined_functions additional param to exclude
	disabled functions). (willianveiga)

- Zlib
  . Fixed bug #73373 (deflate_add does not verify that output was not truncated).
    (Matt Bonneau)

01 Dec 2016, PHP 7.1.0

- Core:
  . Added nullable types. (Levi, Dmitry)
  . Added DFA optimization framework based on e-SSA form. (Dmitry, Nikita)
  . Added specialized opcode handlers (e.g. ZEND_ADD_LONG_NO_OVERFLOW).
    (Dmitry)
  . Added [] = as alternative construct to list() =. (Bob)
  . Added void return type. (Andrea)
  . Added support for negative string offsets in string offset syntax and
    various string functions. (Francois)
  . Added a form of the list() construct where keys can be specified. (Andrea)
  . Implemented safe execution timeout handling, that prevents random crashes
    after "Maximum execution time exceeded" error. (Dmitry)
  . Implemented the RFC `Support Class Constant Visibility`. (Sean DuBois,
    Reeze Xia, Dmitry)
  . Implemented the RFC `Catching multiple exception types`. (Bronislaw Bialek,
    Pierrick)
  . Implemented logging to syslog with dynamic error levels. (Jani Ollikainen)
  . Implemented FR #72614 (Support "nmake test" on building extensions by
    phpize). (Yuji Uchiyama)
  . Implemented RFC: Iterable. (Aaron Piotrowski)
  . Implemented RFC: Closure::fromCallable (Danack)
  . Implemented RFC: Replace "Missing argument" warning with "\ArgumentCountError"
    exception. (Dmitry, Davey)
  . Implemented RFC: Fix inconsistent behavior of $this variable. (Dmitry)
  . Fixed bug #73585 (Logging of "Internal Zend error - Missing class
    information" missing class name). (Laruence)
  . Fixed memory leak(null coalescing operator with Spl hash). (Tyson Andre)
  . Fixed bug #72736 (Slow performance when fetching large dataset with mysqli
    / PDO). (Dmitry)
  . Fixed bug #72482 (Ilegal write/read access caused by gdImageAALine
    overflow). (cmb)
  . Fixed bug #72696 (imagefilltoborder stackoverflow on truecolor images).
    (cmb)
  . Fixed bug #73350 (Exception::__toString() cause circular references).
    (Laruence)
  . Fixed bug #73329 ((Float)"Nano" == NAN). (Anatol)
  . Fixed bug #73288 (Segfault in __clone > Exception.toString > __get).
    (Laruence)
  . Fixed for #73240 (Write out of bounds at number_format). (Stas)
  . Fix pthreads detection when cross-compiling (ffontaine)
  . Fixed bug #73337 (try/catch not working with two exceptions inside a same
    operation). (Dmitry)
  . Fixed bug #73156 (segfault on undefined function). (Dmitry)
  . Fixed bug #73163 (PHP hangs if error handler throws while accessing undef
    const in default value). (Nikita)
  . Fixed bug #73172 (parse error: Invalid numeric literal). (Nikita, Anatol)
  . Fixed bug #73181 (parse_str() without a second argument leads to crash).
    (Nikita)
  . Fixed bug #73025 (Heap Buffer Overflow in virtual_popen of
    zend_virtual_cwd.c). (cmb)
  . Fixed bug #73058 (crypt broken when salt is 'too' long). (Anatol)
  . Fixed bug #72944 (Null pointer deref in zval_delref_p). (Dmitry)
  . Fixed bug #72943 (assign_dim on string doesn't reset hval). (Laruence)
  . Fixed bug #72598 (Reference is lost after array_slice()) (Nikita)
  . Fixed bug #72703 (Out of bounds global memory read in BF_crypt triggered by
    password_verify). (Anatol)
  . Fixed bug #72813 (Segfault with __get returned by ref). (Laruence)
  . Fixed bug #72767 (PHP Segfaults when trying to expand an infinite operator).
    (Nikita)
  . TypeError messages for arg_info type checks will now say "must be ...
    or null" where the parameter or return type accepts null. (Andrea)
  . Fixed bug #72857 (stream_socket_recvfrom read access violation). (Anatol)
  . Fixed bug #72663 (Create an Unexpected Object and Don't Invoke
    __wakeup() in Deserialization). (Stas)
  . Fixed bug #72681 (PHP Session Data Injection Vulnerability). (Stas)
  . Fixed bug #72742 (memory allocator fails to realloc small block to large
    one). (Stas)
  . Fixed URL rewriter. It would not rewrite '//example.com/' URL
    unconditionally. URL rewrite target hosts whitelist is implemented. (Yasuo)
  . Fixed bug #72641 (phpize (on Windows) ignores PHP_PREFIX).
    (Yuji Uchiyama)
  . Fixed bug #72683 (getmxrr broken). (Anatol)
  . Fixed bug #72629 (Caught exception assignment to variables ignores
    references). (Laruence)
  . Fixed bug #72594 (Calling an earlier instance of an included anonymous
    class fatals). (Laruence)
  . Fixed bug #72581 (previous property undefined in Exception after
    deserialization). (Laruence)
  . Fixed bug #72543 (Different references behavior comparing to PHP 5)
    (Laruence, Dmitry, Nikita)
  . Fixed bug #72347 (VERIFY_RETURN type casts visible in finally). (Dmitry)
  . Fixed bug #72216 (Return by reference with finally is not memory safe).
    (Dmitry)
  . Fixed bug #72215 (Wrong return value if var modified in finally). (Dmitry)
  . Fixed bug #71818 (Memory leak when array altered in destructor). (Dmitry)
  . Fixed bug #71539 (Memory error on $arr[$a] =& $arr[$b] if RHS rehashes)
    (Dmitry, Nikita)
  . Added new constant PHP_FD_SETSIZE. (cmb)
  . Added optind parameter to getopt(). (as)
  . Added PHP to SAPI error severity mapping for logs. (Martin Vobruba)
  . Fixed bug #71911 (Unable to set --enable-debug on building extensions by
    phpize on Windows). (Yuji Uchiyama)
  . Fixed bug #29368 (The destructor is called when an exception is thrown from
    the constructor). (Dmitry)
  . Implemented RFC: RNG Fixes. (Leigh)
  . Implemented email validation as per RFC 6531. (Leo Feyer, Anatol)
  . Fixed bug #72513 (Stack-based buffer overflow vulnerability in
    virtual_file_ex). (Stas)
  . Fixed bug #72573 (HTTP_PROXY is improperly trusted by some PHP libraries
    and applications). (Stas)
  . Fixed bug #72523 (dtrace issue with reflection (failed test)). (Laruence)
  . Fixed bug #72508 (strange references after recursive function call and
    "switch" statement). (Laruence)
  . Fixed bug #72441 (Segmentation fault: RFC list_keys). (Laruence)
  . Fixed bug #72395 (list() regression). (Laruence)
  . Fixed bug #72373 (TypeError after Generator function w/declared return type
    finishes). (Nikita)
  . Fixed bug #69489 (tempnam() should raise notice if falling back to temp dir).
    (Laruence, Anatol)
  . Fixed UTF-8 and long path support on Windows. (Anatol)
  . Fixed bug #53432 (Assignment via string index access on an empty string
    converts to array). (Nikita)
  . Fixed bug #62210 (Exceptions can leak temporary variables). (Dmitry, Bob)
  . Fixed bug #62814 (It is possible to stiffen child class members visibility).
    (Nikita)
  . Fixed bug #69989 (Generators don't participate in cycle GC). (Nikita)
  . Fixed bug #70228 (Memleak if return in finally block). (Dmitry)
  . Fixed bug #71266 (Missing separation of properties HT in foreach etc).
    (Dmitry)
  . Fixed bug #71604 (Aborted Generators continue after nested finally).
    (Nikita)
  . Fixed bug #71572 (String offset assignment from an empty string inserts
    null byte). (Francois)
  . Fixed bug #71897 (ASCII 0x7F Delete control character permitted in
    identifiers). (Andrea)
  . Fixed bug #72188 (Nested try/finally blocks losing return value). (Dmitry)
  . Fixed bug #72213 (Finally leaks on nested exceptions). (Dmitry, Nikita)
  . Fixed bug #47517 (php-cgi.exe missing UAC manifest).
    (maxdax15801 at users noreply github com)
  . Change statement and fcall extension handlers to accept frame. (Joe)
  . Number operators taking numeric strings now emit E_NOTICEs or E_WARNINGs
    when given malformed numeric strings. (Andrea)
  . (int), intval() where $base is 10 or unspecified, settype(), decbin(),
    decoct(), dechex(), integer operators and other conversions now always
    respect scientific notation in numeric strings. (Andrea)
  . Raise a compile-time warning on octal escape sequence overflow. (Sara)

- Apache2handler:
  . Enable per-module logging in Apache 2.4+. (Martin Vobruba)

- BCmath:
  . Fix bug #73190 (memcpy negative parameter _bc_new_num_ex). (Stas)

- Bz2:
  . Fixed bug #72837 (integer overflow in bzdecompress caused heap
    corruption). (Stas)
  . Fixed bug #72613 (Inadequate error handling in bzread()). (Stas)

- Calendar:
  . Fix integer overflows (Joshua Rogers)
  . Fixed bug #67976 (cal_days_month() fails for final month of the French
    calendar). (cmb)
  . Fixed bug #71894 (AddressSanitizer: global-buffer-overflow in
    zif_cal_from_jd). (cmb)

- CLI Server:
  . Fixed bug #73360 (Unable to work in root with unicode chars). (Anatol)
  . Fixed bug #71276 (Built-in webserver does not send Date header).
    (see at seos fr)

- COM:
  . Fixed bug #73126 (Cannot pass parameter 1 by reference). (Anatol)
  . Fixed bug #69579 (Invalid free in extension trait). (John Boehr)
  . Fixed bug #72922 (COM called from PHP does not return out parameters).
    (Anatol)
  . Fixed bug #72569 (DOTNET/COM array parameters broke in PHP7). (Anatol)
  . Fixed bug #72498 (variant_date_from_timestamp null dereference). (Anatol)

- Curl
  . Implement support for handling HTTP/2 Server Push. (Davey)
  . Add curl_multi_errno(), curl_share_errno() and curl_share_strerror()
    functions. (Pierrick)
  . Fixed bug #72674 (Heap overflow in curl_escape). (Stas)
  . Fixed bug #72541 (size_t overflow lead to heap corruption). (Stas).
  . Fixed bug #71709 (curl_setopt segfault with empty CURLOPT_HTTPHEADER).
    (Pierrick)
  . Fixed bug #71929 (CURLINFO_CERTINFO data parsing error). (Pierrick)

- Date:
  . Fixed bug #69587 (DateInterval properties and isset). (jhdxr)
  . Fixed bug #73426 (createFromFormat with 'z' format char results in
    incorrect time). (Derick)
  . Fixed bug #45554 (Inconsistent behavior of the u format char). (Derick)
  . Fixed bug #48225 (DateTime parser doesn't set microseconds for "now").
    (Derick)
  . Fixed bug #52514 (microseconds are missing in DateTime class). (Derick)
  . Fixed bug #52519 (microseconds in DateInterval are missing). (Derick)
  . Fixed bug #60089 (DateTime::createFromFormat() U after u nukes microtime).
    (Derick)
  . Fixed bug #64887 (Allow DateTime modification with subsecond items).
    (Derick)
  . Fixed bug #68506 (General DateTime improvments needed for microseconds to
    become useful). (Derick)
  . Fixed bug #73109 (timelib_meridian doesn't parse dots correctly). (Derick)
  . Fixed bug #73247 (DateTime constructor does not initialise microseconds
    property). (Derick)
  . Fixed bug #73147 (Use After Free in PHP7 unserialize()). (Stas)
  . Fixed bug #73189 (Memcpy negative size parameter php_resolve_path). (Stas)
  . Fixed bug #66836 (DateTime::createFromFormat 'U' with pre 1970 dates fails
    parsing). (derick)
  . Invalid serialization data for a DateTime or DatePeriod object will now
    throw an instance of Error from __wakeup() or __set_state() instead of
    resulting in a fatal error. (Aaron Piotrowski)
  . Timezone initialization failure from serialized data will now throw an
    instance of Error from __wakeup() or __set_state() instead of resulting in
    a fatal error. (Aaron Piotrowski)
  . Export date_get_interface_ce() for extension use. (Jeremy Mikola)
  . Fixed bug #63740 (strtotime seems to use both sunday and monday as start of
    week). (Derick)

- Dba:
  . Fixed bug #70825 (Cannot fetch multiple values with group in ini file).
    (cmb)
  . Data modification functions (e.g.: dba_insert()) now throw an instance of
    Error instead of triggering a catchable fatal error if the key is does not
    contain exactly two elements. (Aaron Piotrowski)

- DOM:
  . Fixed bug #73150 (missing NULL check in dom_document_save_html). (Stas)
  . Fixed bug #66502 (DOM document dangling reference). (Sean Heelan, cmb)
  . Invalid schema or RelaxNG validation contexts will throw an instance of
    Error instead of resulting in a fatal error. (Aaron Piotrowski)
  . Attempting to register a node class that does not extend the appropriate
    base class will now throw an instance of Error instead of resulting in a
    fatal error. (Aaron Piotrowski)
  . Attempting to read an invalid or write to a readonly property will throw
    an instance of Error instead of resulting in a fatal error. (Aaron
    Piotrowski)

- DTrace:
  . Disabled PHP call tracing by default (it makes significant overhead).
    This may be enabled again using envirionment variable USE_ZEND_DTRACE=1.
    (Dmitry)

- EXIF:
  . Fixed bug #72735 (Samsung picture thumb not read (zero size)). (Kalle, Remi)
  . Fixed bug #72627 (Memory Leakage In exif_process_IFD_in_TIFF). (Stas)
  . Fixed bug #72603 (Out of bound read in exif_process_IFD_in_MAKERNOTE).
    (Stas)
  . Fixed bug #72618 (NULL Pointer Dereference in exif_process_user_comment).
    (Stas)

- Filter:
  . Fixed bug #72972 (Bad filter for the flags FILTER_FLAG_NO_RES_RANGE and
    FILTER_FLAG_NO_PRIV_RANGE). (julien)
  . Fixed bug #73054 (default option ignored when object passed to int filter).
    (cmb)
  . Fixed bug #71745 (FILTER_FLAG_NO_RES_RANGE does not cover whole 127.0.0.0/8
    range). (bugs dot php dot net at majkl578 dot cz)

- FPM:
  . Fixed bug #72575 (using --allow-to-run-as-root should ignore missing user).
    (gooh)

- FTP:
  . Fixed bug #70195 (Cannot upload file using ftp_put to FTPES with
    require_ssl_reuse). (Benedict Singer)
  . Implemented FR #55651 (Option to ignore the returned FTP PASV address).
    (abrender at elitehosts dot com)

- GD:
  . Fixed bug #73213 (Integer overflow in imageline() with antialiasing). (cmb)
  . Fixed bug #73272 (imagescale() is not affected by, but affects
    imagesetinterpolation()). (cmb)
  . Fixed bug #73279 (Integer overflow in gdImageScaleBilinearPalette()). (cmb)
  . Fixed bug #73280 (Stack Buffer Overflow in GD dynamicGetbuf). (cmb)
  . Fixed bug #50194 (imagettftext broken on transparent background w/o
    alphablending). (cmb)
  . Fixed bug #73003 (Integer Overflow in gdImageWebpCtx of gd_webp.c). (trylab,
    cmb)
  . Fixed bug #53504 (imagettfbbox gives incorrect values for bounding box).
    (Mark Plomer, cmb)
  . Fixed bug #73157 (imagegd2() ignores 3rd param if 4 are given). (cmb)
  . Fixed bug #73155 (imagegd2() writes wrong chunk sizes on boundaries). (cmb)
  . Fixed bug #73159 (imagegd2(): unrecognized formats may result in corrupted
    files). (cmb)
  . Fixed bug #73161 (imagecreatefromgd2() may leak memory). (cmb)
  . Fixed bug #67325 (imagetruecolortopalette: white is duplicated in palette).
    (cmb)
  . Fixed bug #66005 (imagecopy does not support 1bit transparency on truecolor
    images). (cmb)
  . Fixed bug #72913 (imagecopy() loses single-color transparency on palette
    images). (cmb)
  . Fixed bug #68716 (possible resource leaks in _php_image_convert()). (cmb)
  . Fixed bug #72709 (imagesetstyle() causes OOB read for empty $styles). (cmb)
  . Fixed bug #72697 (select_colors write out-of-bounds). (Stas)
  . Fixed bug #72730 (imagegammacorrect allows arbitrary write access). (Stas)
  . Fixed bug #72596 (imagetypes function won't advertise WEBP support). (cmb)
  . Fixed bug #72604 (imagearc() ignores thickness for full arcs). (cmb)
  . Fixed bug #70315 (500 Server Error but page is fully rendered). (cmb)
  . Fixed bug #43828 (broken transparency of imagearc for truecolor in
    blendingmode). (cmb)
  . Fixed bug #72512 (gdImageTrueColorToPaletteBody allows arbitrary write/read
    access). (Pierre)
  . Fixed bug #72519 (imagegif/output out-of-bounds access). (Pierre)
  . Fixed bug #72558 (Integer overflow error within _gdContributionsAlloc()).
    (Pierre)
  . Fixed bug #72482 (Ilegal write/read access caused by gdImageAALine
    overflow). (Pierre)
  . Fixed bug #72494 (imagecropauto out-of-bounds access). (Fernando, Pierre,
    cmb)
  . Fixed bug #72404 (imagecreatefromjpeg fails on selfie). (cmb)
  . Fixed bug #43475 (Thick styled lines have scrambled patterns). (cmb)
  . Fixed bug #53640 (XBM images require width to be multiple of 8). (cmb)
  . Fixed bug #64641 (imagefilledpolygon doesn't draw horizontal line). (cmb)

- Hash:
  . Added SHA3 fixed mode algorithms (224, 256, 384, and 512 bit). (Sara)
  . Added SHA512/256 and SHA512/224 algorithms. (Sara)

- iconv:
  . Fixed bug #72320 (iconv_substr returns false for empty strings). (cmb)

- IMAP:
  . Fixed bug #73418 (Integer Overflow in "_php_imap_mail" leads to crash).
    (Anatol)
  . An email address longer than 16385 bytes will throw an instance of Error
    instead of resulting in a fatal error. (Aaron Piotrowski)

- Interbase:
  . Fixed bug #73512 (Fails to find firebird headers as don't use fb_config
    output). (Remi)

- Intl:
  . Fixed bug #73007 (add locale length check). (Stas)
  . Fixed bug #73218 (add mitigation for ICU int overflow). (Stas)
  . Fixed bug #65732 (grapheme_*() is not Unicode compliant on CR LF
    sequence). (cmb)
  . Fixed bug #73007 (add locale length check). (Stas)
  . Fixed bug #72639 (Segfault when instantiating class that extends
    IntlCalendar and adds a property). (Laruence)
  . Fixed bug #72658 (Locale::lookup() / locale_lookup() hangs if no match
    found). (Anatol)
  . Partially fixed #72506 (idn_to_ascii for UTS #46 incorrect for long domain
    names). (cmb)
  . Fixed bug #72533 (locale_accept_from_http out-of-bounds access). (Stas)
  . Failure to call the parent constructor in a class extending Collator
    before invoking the parent methods will throw an instance of Error
    instead of resulting in a recoverable fatal error. (Aaron Piotrowski)
  . Cloning a Transliterator object may will now throw an instance of Error
    instead of resulting in a fatal error if cloning the internal
    transliterator fails. (Aaron Piotrowski)
  . Added IntlTimeZone::getWindowsID() and
    IntlTimeZone::getIDForWindowsID(). (Sara)
  . Fixed bug #69374 (IntlDateFormatter formatObject returns wrong utf8 value).
    (lenhatanh86 at gmail com)
  . Fixed bug #69398 (IntlDateFormatter formatObject returns wrong value when
    time style is NONE). (lenhatanh86 at gmail com)

- JSON:
  . Introduced encoder struct instead of global which fixes bugs #66025 and
    #73254 related to pretty print indentation. (Jakub Zelenka)
  . Fixed bug #73113 (Segfault with throwing JsonSerializable). (julien)
  . Implemented earlier return when json_encode fails, fixes bugs #68992
    (Stacking exceptions thrown by JsonSerializable) and #70275 (On recursion
    error, json_encode can eat up all system memory). (Jakub Zelenka)
  . Implemented FR #46600 ("_empty_" key in objects). (Jakub Zelenka)
  . Exported JSON parser API including json_parser_method that can be used
    for implementing custom logic when parsing JSON. (Jakub Zelenka)
  . Escaped U+2028 and U+2029 when JSON_UNESCAPED_UNICODE is supplied as
    json_encode options and added JSON_UNESCAPED_LINE_TERMINATORS to restore
    the previous behaviour. (Eddie Kohler)

- LDAP:
  . Providing an unknown modification type to ldap_batch_modify() will now
    throw an instance of Error instead of resulting in a fatal error.
    (Aaron Piotrowski)

- Mbstring:
  . Fixed bug #73532 (Null pointer dereference in mb_eregi). (Laruence)
  . Fixed bug #66964 (mb_convert_variables() cannot detect recursion) (Yasuo)
  . Fixed bug #72992 (mbstring.internal_encoding doesn't inherit default_charset).
    (Yasuo)
  . Fixed bug #66797 (mb_substr only takes 32-bit signed integer). (cmb)
  . Fixed bug #72711 (`mb_ereg` does not clear the `$regs` parameter on
    failure). (ju1ius)
  . Fixed bug #72691 (mb_ereg_search raises a warning if a match zero-width).
    (cmb)
  . Fixed bug #72693 (mb_ereg_search increments search position when a match
    zero-width). (cmb)
  . Fixed bug #72694 (mb_ereg_search_setpos does not accept a string's last
    position). (cmb)
  . Fixed bug #72710 (`mb_ereg` causes buffer overflow on regexp compile error).
    (ju1ius)
  . Deprecated mb_ereg_replace() eval option. (Rouven Weßling, cmb)
  . Fixed bug #69151 (mb_ereg should reject ill-formed byte sequence).
    (Masaki Kagaya)
  . Fixed bug #72405 (mb_ereg_replace - mbc_to_code (oniguruma) -
    oob read access). (Laruence)
  . Fixed bug #72399 (Use-After-Free in MBString (search_re)). (Laruence)
  . mb_ereg() and mb_eregi() will now throw an instance of ParseError if an
    invalid PHP expression is provided and the 'e' option is used. (Aaron
    Piotrowski)

- Mcrypt:
  . Deprecated ext/mcrypt. (Scott Arciszewski, cmb)
  . Fixed bug #72782 (Heap Overflow due to integer overflows). (Stas)
  . Fixed bug #72551, bug #72552 (In correct casting from size_t to int lead to
    heap overflow in mdecrypt_generic). (Stas)
  . mcrypt_encrypt() and mcrypt_decrypt() will throw an instance of Error
    instead of resulting in a fatal error if mcrypt cannot be initialized.
    (Aaron Piotrowski)

- Mysqli:
  . Attempting to read an invalid or write to a readonly property will throw
    an instance of Error instead of resulting in a fatal error. (Aaron
    Piotrowski)

- Mysqlnd:
  . Fixed bug #64526 (Add missing mysqlnd.* parameters to php.ini-*). (cmb)
  . Fixed bug #71863 (Segfault when EXPLAIN with "Unknown column" error when
    using MariaDB). (Andrey)
  . Fixed bug #72701 (mysqli_get_host_info() wrong output). (Anatol)

- OCI8
  . Fixed bug #71148 (Bind reference overwritten on PHP 7). (Oracle Corp.)
  . Fixed invalid handle error with Implicit Result Sets. (Chris Jones)
  . Fixed bug #72524 (Binding null values triggers ORA-24816 error). (Chris Jones)

- ODBC:
  . Fixed bug #73448 (odbc_errormsg returns trash, always 513 bytes).
    (Anatol)

- Opcache:
  . Fixed bug #73583 (Segfaults when conditionally declared class and function
    have the same name). (Laruence)
  . Fixed bug #69090 (check cached files permissions)
  . Fixed bug #72982 (Memory leak in zend_accel_blacklist_update_regexp()
    function). (Laruence)
  . Fixed bug #72949 (Typo in opcache error message). (cmb)
  . Fixed bug #72762 (Infinite loop while parsing a file with opcache enabled).
    (Nikita)
  . Fixed bug #72590 (Opcache restart with kill_all_lockers does not work).
    (Keyur)

- OpenSSL:
  . Fixed bug #73478 (openssl_pkey_new() generates wrong pub/priv keys with
    Diffie Hellman). (Jakub Zelenka)
  . Fixed bug #73276 (crash in openssl_random_pseudo_bytes function). (Stas)
  . Fixed bug #73072 (Invalid path SNI_server_certs causes segfault).
    (Jakub Zelenka)
  . Fixed bug #72360 (ext/openssl build failure with OpenSSL 1.1.0).
    (Jakub Zelenka)
  . Bumped a minimal version to 1.0.1. (Jakub Zelenka)
  . Dropped support for SSL2. (Remi)
  . Implemented FR #61204 (Add elliptic curve support for OpenSSL).
    (Dominic Luechinger)
  . Implemented FR #67304 (Added AEAD support [CCM and GCM modes] to
    openssl_encrypt and openssl_decrypt). (Jakub Zelenka)
  . Implemented error storing to the global queue and cleaning up the OpenSSL
    error queue (resolves bugs #68276 and #69882). (Jakub Zelenka)

- Pcntl
  . Implemented asynchronous signal handling without TICKS. (Dmitry)
  . Added pcntl_signal_get_handler() that returns the current signal handler
    for a particular signal. Addresses FR #72409. (David Walker)
  . Add signinfo to pcntl_signal() handler args (Bishop Bettini, David Walker)

- PCRE:
  . Fixed bug #73483 (Segmentation fault on pcre_replace_callback). (Laruence)
  . Fixed bug #73612 (preg_*() may leak memory). (cmb)
  . Fixed bug #73392 (A use-after-free in zend allocator management).
    (Laruence)
  . Fixed bug #73121 (Bundled PCRE doesn't compile because JIT isn't supported
    on s390). (Anatol)
  . Fixed bug #72688 (preg_match missing group names in matches). (cmb)
  . Downgraded to PCRE 8.38. (Anatol)
  . Fixed bug #72476 (Memleak in jit_stack). (Laruence)
  . Fixed bug #72463 (mail fails with invalid argument). (Anatol)
  . Upgraded to PCRE 8.39. (Anatol)

- PDO:
  . Fixed bug #72788 (Invalid memory access when using persistent PDO
    connection). (Keyur)
  . Fixed bug #72791 (Memory leak in PDO persistent connection handling). (Keyur)
  . Fixed bug #60665 (call to empty() on NULL result using PDO::FETCH_LAZY
    returns false). (cmb)

- PDO_DBlib:
  . Fixed bug #72414 (Never quote values as raw binary data). (Adam Baratz)
  . Allow \PDO::setAttribute() to set query timeouts. (Adam Baratz)
  . Handle SQLDECIMAL/SQLNUMERIC types, which are used by later TDS versions.
    (Adam Baratz)
  . Add common PDO test suite. (Adam Baratz)
  . Free error and message strings when cleaning up PDO instances.
    (Adam Baratz)
  . Fixed bug #67130 (\PDOStatement::nextRowset() should succeed when all rows
    in current rowset haven't been fetched). (Peter LeBrun)
  . Ignore potentially misleading dberr values. (Chris Kings-Lynne)
  . Implemented stringify 'uniqueidentifier' fields.
    (Alexander Zhuravlev, Adam Baratz)

- PDO_Firebird:
  . Fixed bug #73087, #61183, #71494 (Memory corruption in bindParam).
    (Dorin Marcoci)
  . Fixed bug #60052 (Integer returned as a 64bit integer on X86_64). (Mariuz)

- PDO_pgsql:
  . Fixed bug #70313 (PDO statement fails to throw exception). (Matteo)
  . Fixed bug #72570 (Segmentation fault when binding parameters on a query
    without placeholders). (Matteo)
  . Implemented FR #72633 (Postgres PDO lastInsertId() should work without
    specifying a sequence). (Pablo Santiago Sánchez, Matteo)

- Phar:
  . Fixed bug #72928 (Out of bound when verify signature of zip phar in
    phar_parse_zipfile). (Stas)
  . Fixed bug #73035 (Out of bound when verify signature of tar phar in
    phar_parse_tarfile). (Stas)

- phpdbg:
  . Added generator command for inspection of currently alive generators. (Bob)

- Postgres:
  . Fixed bug #73498 (Incorrect SQL generated for pg_copy_to()). (Craig Duncan)
  . Implemented FR #31021 (pg_last_notice() is needed to get all notice
    messages). (Yasuo)
  . Implemented FR #48532 (Allow pg_fetch_all() to index numerically). (Yasuo)

- Readline:
  . Fixed bug #72538 (readline_redisplay crashes php). (Laruence)

- Reflection
  . Undo backwards compatiblity break in ReflectionType->__toString() and
    deprecate via documentation instead. (Nikita)
  . Reverted prepending \ for class names. (Trowski)
  . Implemented request #38992 (invoke() and invokeArgs() static method calls
    should match). (cmb).
  . Add ReflectionNamedType::getName(). This method should be used instead of
    ReflectionType::__toString()
  . Prepend \ for class names and ? for nullable types returned from
    ReflectionType::__toString(). (Trowski)
  . Fixed bug #72661 (ReflectionType::__toString crashes with iterable).
    (Laruence)
  . Fixed bug #72222 (ReflectionClass::export doesn't handle array constants).
    (Nikita Nefedov)
  . Failure to retrieve a reflection object or retrieve an object property
    will now throw an instance of Error instead of resulting in a fatal error.
    (Aaron Piotrowski)
  . Fix #72209 (ReflectionProperty::getValue() doesn't fail if object doesn't match type). (Joe)

- Session:
  . Fixed bug #73273 (session_unset() empties values from all variables in which
    is $_session stored). (Nikita)
  . Fixed bug #73100 (session_destroy null dereference in ps_files_path_create).
    (cmb)
  . Fixed bug #68015 (Session does not report invalid uid for files save handler).
    (Yasuo)
  . Fixed bug #72940 (SID always return "name=ID", even if session
    cookie exist). (Yasuo)
  . Implemented session_gc() (Yasuo)
    https://wiki.php.net/rfc/session-create-id
  . Implemented session_create_id() (Yasuo)
    https://wiki.php.net/rfc/session-gc
  . Implemented RFC: Session ID without hashing. (Yasuo)
    https://wiki.php.net/rfc/session-id-without-hashing
  . Fixed bug #72531 (ps_files_cleanup_dir Buffer overflow). (Laruence)
  . Custom session handlers that do not return strings for session IDs will
    now throw an instance of Error instead of resulting in a fatal error
    when a function is called that must generate a session ID.
    (Aaron Piotrowski)
  . An invalid setting for session.hash_function will throw an instance of
    Error instead of resulting in a fatal error when a session ID is created.
    (Aaron Piotrowski)
  . Fixed bug #72562 (Use After Free in unserialize() with Unexpected Session
    Deserialization). (Stas)
  . Improved fix for bug #68063 (Empty session IDs do still start sessions).
    (Yasuo)
  . Fixed bug #71038 (session_start() returns TRUE on failure).
    Session save handlers must return 'string' always for successful read.
    i.e. Non-existing session read must return empty string. PHP 7.0 is made
    not to tolerate buggy return value. (Yasuo)
  . Fixed bug #71394 (session_regenerate_id() must close opened session on
    errors). (Yasuo)

- SimpleXML:
  . Fixed bug #73293 (NULL pointer dereference in SimpleXMLElement::asXML()).
    (Stas)
  . Fixed bug #72971 (SimpleXML isset/unset do not respect namespace). (Nikita)
  . Fixed bug #72957 (Null coalescing operator doesn't behave as expected with
    SimpleXMLElement). (Nikita)
  . Fixed bug #72588 (Using global var doesn't work while accessing SimpleXML
    element). (Laruence)
  . Creating an unnamed or duplicate attribute will throw an instance of Error
    instead of resulting in a fatal error. (Aaron Piotrowski)

- SNMP:
  . Fixed bug #72708 (php_snmp_parse_oid integer overflow in memory
    allocation). (djodjo at gmail dot com)
  . Fixed bug #72479 (Use After Free Vulnerability in SNMP with GC and
    unserialize()). (Stas)

- Soap:
  . Fixed bug #73538 (SoapClient::__setSoapHeaders doesn't overwrite SOAP
    headers). (duncan3dc)
  . Fixed bug #73452 (Segfault (Regression for #69152)). (Dmitry)
  . Fixed bug #73037 (SoapServer reports Bad Request when gzipped). (Anatol)
  . Fixed bug #73237 (Nested object in "any" element overwrites other fields).
    (Keith Smiley)
  . Fixed bug #69137 (Peer verification fails when using a proxy with SoapClient)
    (Keith Smiley)
  . Fixed bug #71711 (Soap Server Member variables reference bug). (Nikita)
  . Fixed bug #71996 (Using references in arrays doesn't work like expected).
    (Nikita)

- SPL:
  . Fixed bug #73423 (Reproducible crash with GDB backtrace). (Laruence)
  . Fixed bug #72888 (Segfault on clone on splFileObject). (Laruence)
  . Fixed bug #73029 (Missing type check when unserializing SplArray). (Stas)
  . Fixed bug #72646 (SplFileObject::getCsvControl does not return the escape
    character). (cmb)
  . Fixed bug #72684 (AppendIterator segfault with closed generator). (Pierrick)
  . Attempting to clone an SplDirectory object will throw an instance of Error
    instead of resulting in a fatal error. (Aaron Piotrowski)
  . Calling ArrayIterator::append() when iterating over an object will throw an
    instance of Error instead of resulting in a fatal error. (Aaron Piotrowski)
  . Fixed bug #55701 (GlobIterator throws LogicException). (Valentin VĂLCIU)

- SQLite3:
  . Update to SQLite 3.15.1. (cmb)
  . Fixed bug #73530 (Unsetting result set may reset other result set). (cmb)
  . Fixed bug #73333 (2147483647 is fetched as string). (cmb)
  . Fixed bug #72668 (Spurious warning when exception is thrown in user defined
    function). (Laruence)
  . Implemented FR #72653 (SQLite should allow opening with empty filename).
    (cmb)
  . Fixed bug #70628 (Clearing bindings on an SQLite3 statement doesn't work).
    (cmb)
  . Implemented FR #71159 (Upgraded bundled SQLite lib to 3.9.2). (Laruence)

- Standard:
  . Fixed bug #73297 (HTTP stream wrapper should ignore HTTP 100 Continue).
    (rowan dot collins at gmail dot com)
  . Fixed bug #73303 (Scope not inherited by eval in assert()). (nikic)
  . Fixed bug #73192 (parse_url return wrong hostname). (Nikita)
  . Fixed bug #73203 (passing additional_parameters causes mail to fail). (cmb)
  . Fixed bug #73203 (passing additional_parameters causes mail to fail). (cmb)
  . Fixed bug #72920 (Accessing a private constant using constant() creates
    an exception AND warning). (Laruence)
  . Fixed bug #65550 (get_browser() incorrectly parses entries with "+" sign).
    (cmb)
  . Fixed bug #71882 (Negative ftruncate() on php://memory exhausts memory).
    (cmb)
  . Fixed bug #55451 (substr_compare NULL length interpreted as 0). (Lauri
    Kenttä)
  . Fixed bug #72278 (getimagesize returning FALSE on valid jpg). (cmb)
  . Fixed bug #61967 (unset array item in array_walk_recursive cause
    inconsistent array). (Nikita)
  . Fixed bug #62607 (array_walk_recursive move internal pointer). (Nikita)
  . Fixed bug #69068 (Exchanging array during array_walk -> memory errors).
    (Nikita)
  . Fixed bug #70713 (Use After Free Vulnerability in array_walk()/
    array_walk_recursive()). (Nikita)
  . Fixed bug #72622 (array_walk + array_replace_recursive create references
    from nothing). (Laruence)
  . Fixed bug #72330 (CSV fields incorrectly split if escape char followed by
    UTF chars). (cmb)
  . Implemented RFC: More precise float values. (Jakub Zelenka, Yasuo)
  . array_multisort now uses zend_sort instead zend_qsort. (Laruence)
  . Fixed bug #72505 (readfile() mangles files larger than 2G). (Cschneid)
  . assert() will throw a ParseError when evaluating a string given as the first
    argument if the PHP code is invalid instead of resulting in a catchable
    fatal error. (Aaron Piotrowski)
  . Calling forward_static_call() outside of a class scope will now throw an
    instance of Error instead of resulting in a fatal error. (Aaron Piotrowski)
  . Added is_iterable() function. (Aaron Piotrowski)
  . Fixed bug #72306 (Heap overflow through proc_open and $env parameter).
    (Laruence)
  . Fixed bug #71100 (long2ip() doesn't accept integers in strict mode).
    (Laruence)
  . Implemented FR #55716 (Add an option to pass a custom stream context to
    get_headers()). (Ferenc)
  . Additional validation for parse_url() for login/pass components).
    (Ilia) (Julien)
  . Implemented FR #69359 (Provide a way to fetch the current environment
    variables). (Ferenc)
  . unpack() function accepts an additional optional argument $offset. (Dmitry)
  . Implemented #51879 stream context socket option tcp_nodelay (Joe)

- Streams:
  . Fixed bug #73586 (php_user_filter::$stream is not set to the stream the
    filter is working on). (Dmitry)
  . Fixed bug #72853 (stream_set_blocking doesn't work). (Laruence)
  . Fixed bug #72743 (Out-of-bound read in php_stream_filter_create).
    (Loianhtuan)
  . Implemented FR #27814 (Multiple small packets send for HTTP request).
    (vhuk)
  . Fixed bug #72764 (ftps:// opendir wrapper data channel encryption fails
    with IIS FTP 7.5, 8.5). (vhuk)
  . Fixed bug #72810 (Missing SKIP_ONLINE_TESTS checks). (vhuk)
  . Fixed bug #41021 (Problems with the ftps wrapper). (vhuk)
  . Fixed bug #54431 (opendir() does not work with ftps:// wrapper). (vhuk)
  . Fixed bug #72667 (opendir() with ftp:// attempts to open data stream for
    non-existent directories). (vhuk)
  . Fixed bug #72771 (ftps:// wrapper is vulnerable to protocol downgrade
    attack). (Stas)
  . Fixed bug #72534 (stream_socket_get_name crashes). (Anatol)
  . Fixed bug #72439 (Stream socket with remote address leads to a segmentation
    fault). (Laruence)

- sysvshm:
  . Fixed bug #72858 (shm_attach null dereference). (Anatol)

- Tidy:
  . Implemented support for libtidy 5.0.0 and above. (Michael Orlitzky, Anatol)
  . Creating a tidyNode manually will now throw an instance of Error instead of
    resulting in a fatal error. (Aaron Piotrowski)

- Wddx:
  . Fixed bug #73331 (NULL Pointer Dereference in WDDX Packet Deserialization
    with PDORow). (Stas)
  . Fixed bug #72142 (WDDX Packet Injection Vulnerability in
    wddx_serialize_value()). (Taoguang Chen)
  . Fixed bug #72749 (wddx_deserialize allows illegal memory access) (Stas)
  . Fixed bug #72750 (wddx_deserialize null dereference). (Stas)
  . Fixed bug #72790 (wddx_deserialize null dereference with invalid xml).
    (Stas)
  . Fixed bug #72799 (wddx_deserialize null dereference in
    php_wddx_pop_element). (Stas)
  . Fixed bug #72860 (wddx_deserialize use-after-free). (Stas)
  . Fixed bug #73065 (Out-Of-Bounds Read in php_wddx_push_element). (Stas)
  . Fixed bug #72564 (boolean always deserialized as "true") (Remi)
  . A circular reference when serializing will now throw an instance of Error
    instead of resulting in a fatal error. (Aaron Piotrowski)

- XML:
  . Fixed bug #72135 (malformed XML causes fault) (edgarsandi)
  . Fixed bug #72714 (_xml_startElementHandler() segmentation fault). (cmb)
  . Fixed bug #72085 (SEGV on unknown address zif_xml_parse). (cmb)

- XMLRPC:
  . Fixed bug #72647 (xmlrpc_encode() unexpected output after referencing
    array elements). (Laruence)
  . Fixed bug #72606 (heap-buffer-overflow (write) simplestring_addn
    simplestring.c). (Stas)
  . A circular reference when serializing will now throw an instance of Error
    instead of resulting in a fatal error. (Aaron Piotrowski)

- Zip:
  . Fixed bug #68302 (impossible to compile php with zip support). (cmb)
  . Fixed bug #72660 (NULL Pointer dereference in zend_virtual_cwd).
    (Laruence)
  . Fixed bug #72520 (Stack-based buffer overflow vulnerability in
    php_stream_zip_opener). (Stas)
  . ZipArchive::addGlob() will throw an instance of Error instead of resulting
    in a fatal error if glob support is not available. (Aaron Piotrowski)
